/**
 */
package de.mdelab.mlsdm;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Activity Node Container</b></em>'. <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Superclass of elements that contain activity nodes, edges, etc.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlsdm.ActivityNodeContainer#getEdges <em>Edges</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.ActivityNodeContainer#getNodes <em>Nodes</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.ActivityNodeContainer#getSemaphores <em>Semaphores</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.ActivityNodeContainer#getSynchronizationEdges <em>Synchronization Edges</em>}</li>
 * </ul>
 *
 * @see de.mdelab.mlsdm.MlsdmPackage#getActivityNodeContainer()
 * @model abstract="true"
 * @generated
 */
public interface ActivityNodeContainer extends EObject {
	/**
	 * Returns the value of the '<em><b>Edges</b></em>' containment reference list.
	 * The list contents are of type {@link de.mdelab.mlsdm.ActivityEdge}.
	 * It is bidirectional and its opposite is '{@link de.mdelab.mlsdm.ActivityEdge#getActivityNodeContainer <em>Activity Node Container</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Edges</em>' containment reference list isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Edges</em>' containment reference list.
	 * @see de.mdelab.mlsdm.MlsdmPackage#getActivityNodeContainer_Edges()
	 * @see de.mdelab.mlsdm.ActivityEdge#getActivityNodeContainer
	 * @model opposite="activityNodeContainer" containment="true" ordered="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ActivityNodeContainer!edges'"
	 * @generated
	 */
	EList<ActivityEdge> getEdges();

	/**
	 * Returns the value of the '<em><b>Nodes</b></em>' containment reference list.
	 * The list contents are of type {@link de.mdelab.mlsdm.ActivityNode}.
	 * It is bidirectional and its opposite is '{@link de.mdelab.mlsdm.ActivityNode#getActivityNodeContainer <em>Activity Node Container</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Nodes</em>' containment reference list isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Nodes</em>' containment reference list.
	 * @see de.mdelab.mlsdm.MlsdmPackage#getActivityNodeContainer_Nodes()
	 * @see de.mdelab.mlsdm.ActivityNode#getActivityNodeContainer
	 * @model opposite="activityNodeContainer" containment="true" required="true" ordered="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ActivityNodeContainer!nodes'"
	 * @generated
	 */
	EList<ActivityNode> getNodes();

	/**
	 * Returns the value of the '<em><b>Semaphores</b></em>' containment reference list.
	 * The list contents are of type {@link de.mdelab.mlsdm.Semaphore}.
	 * It is bidirectional and its opposite is '{@link de.mdelab.mlsdm.Semaphore#getActivityNodeContainer <em>Activity Node Container</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Semaphores</em>' containment reference list
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Semaphores</em>' containment reference list.
	 * @see de.mdelab.mlsdm.MlsdmPackage#getActivityNodeContainer_Semaphores()
	 * @see de.mdelab.mlsdm.Semaphore#getActivityNodeContainer
	 * @model opposite="activityNodeContainer" containment="true" ordered="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ActivityNodeContainer!semaphores'"
	 * @generated
	 */
	EList<Semaphore> getSemaphores();

	/**
	 * Returns the value of the '<em><b>Synchronization Edges</b></em>' containment reference list.
	 * The list contents are of type {@link de.mdelab.mlsdm.SynchronizationEdge}.
	 * It is bidirectional and its opposite is '{@link de.mdelab.mlsdm.SynchronizationEdge#getActivityNodeContainer <em>Activity Node Container</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Synchronization Edges</em>' containment
	 * reference list isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Synchronization Edges</em>' containment reference list.
	 * @see de.mdelab.mlsdm.MlsdmPackage#getActivityNodeContainer_SynchronizationEdges()
	 * @see de.mdelab.mlsdm.SynchronizationEdge#getActivityNodeContainer
	 * @model opposite="activityNodeContainer" containment="true" ordered="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ActivityNodeContainer!synchronizationEdges'"
	 * @generated
	 */
	EList<SynchronizationEdge> getSynchronizationEdges();

} // ActivityNodeContainer
