/**
 */
package de.mdelab.mlsdm;

import java.util.Map;
import org.eclipse.emf.common.util.DiagnosticChain;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Release Edge</b></em>'. <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * When the ActivityEdge is executed, a number of tokens is released to the Semaphore.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlsdm.ReleaseEdge#getActivityEdge <em>Activity Edge</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.ReleaseEdge#getSemaphore <em>Semaphore</em>}</li>
 * </ul>
 *
 * @see de.mdelab.mlsdm.MlsdmPackage#getReleaseEdge()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='ActivityEdgeSpecified'"
 * @generated
 */
public interface ReleaseEdge extends SynchronizationEdge {
	/**
	 * Returns the value of the '<em><b>Activity Edge</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link de.mdelab.mlsdm.ActivityEdge#getReleaseEdges <em>Release Edges</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Activity Edge</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Activity Edge</em>' reference.
	 * @see #setActivityEdge(ActivityEdge)
	 * @see de.mdelab.mlsdm.MlsdmPackage#getReleaseEdge_ActivityEdge()
	 * @see de.mdelab.mlsdm.ActivityEdge#getReleaseEdges
	 * @model opposite="releaseEdges" resolveProxies="false" required="true"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ReleaseEdge!activityEdge'"
	 * @generated
	 */
	ActivityEdge getActivityEdge();

	/**
	 * Sets the value of the '{@link de.mdelab.mlsdm.ReleaseEdge#getActivityEdge <em>Activity Edge</em>}' reference.
	 * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * @param value the new value of the '<em>Activity Edge</em>' reference.
	 * @see #getActivityEdge()
	 * @generated
	 */
	void setActivityEdge(ActivityEdge value);

	/**
	 * Returns the value of the '<em><b>Semaphore</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link de.mdelab.mlsdm.Semaphore#getReleaseEdges <em>Release Edges</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Semaphore</em>' reference isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Semaphore</em>' reference.
	 * @see #setSemaphore(Semaphore)
	 * @see de.mdelab.mlsdm.MlsdmPackage#getReleaseEdge_Semaphore()
	 * @see de.mdelab.mlsdm.Semaphore#getReleaseEdges
	 * @model opposite="releaseEdges" resolveProxies="false" required="true"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel get='throw new UnsupportedOperationException();  // FIXME Unimplemented http://www.mdelab.de/mlsdm/1.0!ReleaseEdge!semaphore'"
	 * @generated
	 */
	Semaphore getSemaphore();

	/**
	 * Sets the value of the '{@link de.mdelab.mlsdm.ReleaseEdge#getSemaphore
	 * <em>Semaphore</em>}' reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @param value
	 *            the new value of the '<em>Semaphore</em>' reference.
	 * @see #getSemaphore()
	 * @generated
	 */
	void setSemaphore(Semaphore value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot body='Tuple {\n\tmessage : String = \'Activity edge of release edge \' + self.toString() + \' must be specified.\',\n\tstatus : Boolean = \n\t\tif self.activityEdge &lt;&gt; null then\n\t\t\ttrue\n\t\telse\n\t\t\tnull\n\t\tendif\n}.status'"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='final &lt;%java.lang.String%&gt; constraintName = \"ReleaseEdge::ActivityEdgeSpecified\";\ntry {\n\t/**\n\t *\n\t * inv ActivityEdgeSpecified:\n\t *   let severity : Integer[1] = constraintName.getSeverity()\n\t *   in\n\t *     if severity &lt;= 0\n\t *     then true\n\t *     else\n\t *       let\n\t *         result : OclAny[1] = let\n\t *           status : Boolean[?] = if self.activityEdge &lt;&gt; null\n\t *           then true\n\t *           else null\n\t *           endif\n\t *         in\n\t *           if status = true\n\t *           then true\n\t *           else\n\t *             Tuple{message = \'Activity edge of release edge \' +\n\t *               self.toString() + \' must be specified.\', status = status\n\t *             }\n\t *           endif\n\t *       in\n\t *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)\n\t *     endif\n\t \052/\n\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.evaluation.Executor%&gt; executor = &lt;%org.eclipse.ocl.pivot.utilities.PivotUtil%&gt;.getExecutor(this, context);\n\tfinal /*@NonInvalid\052/ &lt;%org.eclipse.ocl.pivot.values.IntegerValue%&gt; severity_0 = &lt;%org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation%&gt;.INSTANCE.evaluate(executor, &lt;%de.mdelab.mlsdm.MlsdmPackage%&gt;.Literals.RELEASE_EDGE___ACTIVITY_EDGE_SPECIFIED__DIAGNOSTICCHAIN_MAP);\n\tfinal /*@NonInvalid\052/ boolean le = &lt;%org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation%&gt;.INSTANCE.evaluate(executor, severity_0, &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.INT_0).booleanValue();\n\t/*@NonInvalid\052/ boolean symbol_0;\n\tif (le) {\n\t\tsymbol_0 = true;\n\t}\n\telse {\n\t\tfinal /*@NonInvalid\052/ boolean logDiagnostic = &lt;%org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation%&gt;.INSTANCE.evaluate(executor, &lt;%org.eclipse.ocl.pivot.ids.TypeId%&gt;.BOOLEAN, constraintName, this, (Object)null, diagnostics, context, (Object)null, severity_0, &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.TRUE_VALUE, &lt;%de.mdelab.mlsdm.MlsdmTables%&gt;.INT_0).booleanValue();\n\t\tsymbol_0 = logDiagnostic;\n\t}\n\treturn symbol_0;\n}\ncatch (&lt;%java.lang.Throwable%&gt; e) {\n\treturn &lt;%org.eclipse.ocl.pivot.utilities.ValueUtil%&gt;.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);\n}'"
	 * @generated
	 */
	boolean ActivityEdgeSpecified(DiagnosticChain diagnostics, Map<Object, Object> context);

} // ReleaseEdge
