package de.mdelab.mlsdm.diagram.custom.edit.parts;

import org.eclipse.draw2d.IFigure;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.gmf.runtime.notation.Edge;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.mlsdm.diagram.edit.parts.MapEntryLinkValueTargetEditPart;
import de.mdelab.mlstorypatterns.MapEntryLink;
import de.mdelab.mlstorypatterns.ModifierEnum;
import de.mdelab.mlstorypatterns.StoryPatternElement;
import de.mdelab.mlstorypatterns.StoryPatternObject;
import de.mdelab.mlstorypatterns.diagram.custom.edit.parts.EditPartUtil;


public class CustomMapEntryLinkValueTargetEditPart extends MapEntryLinkValueTargetEditPart
{

	public CustomMapEntryLinkValueTargetEditPart(View view)
	{
		super(view);
	}

	@Override
	protected void addNotationalListeners()
	{
		super.addNotationalListeners();

		MapEntryLink mapEntryStoryPatternLink = (MapEntryLink) ((Edge) getModel()).getElement();

		addListenerFilter("MapEntryStoryPatternLink", this, mapEntryStoryPatternLink);
	}

	@Override
	protected void handleNotificationEvent(Notification notification)
	{
		if (notification.getEventType() != Notification.REMOVE
				&& (notification.getNotifier() instanceof MapEntryLink || notification.getNotifier() instanceof StoryPatternObject))
		{
			adaptColor();
		}

		super.handleNotificationEvent(notification);
	}

	@Override
	protected void refreshVisuals()
	{
		super.refreshVisuals();
		adaptColor();
	}

	protected void adaptColor()
	{
		if (((Edge) this.getModel()).getSource() != null)
		{
			ModifierEnum modifier = ((StoryPatternElement) ((Edge) this.getModel()).getSource().getElement())
					.getModifier();

			EditPartUtil.adaptColor(getPrimaryShape(), modifier);

			for (Object o : getPrimaryShape().getChildren())
			{
				EditPartUtil.adaptColor((IFigure) o, modifier);
			}
			if (((MapEntryLink) ((Edge) this.getModel()).getElement()) !=null){
			EditPartUtil.adaptLineStyle(getPrimaryShape(),
					((MapEntryLink) ((Edge) this.getModel()).getElement()).getMatchType());
			}
		}
	}
}
