package de.mdelab.mlsdm.diagram.edit.commands;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.common.core.command.ICommand;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.emf.type.core.commands.EditElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ConfigureRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateRelationshipRequest;

import de.mdelab.mlsdm.diagram.edit.policies.MlsdmBaseItemSemanticEditPolicy;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.ExpressionLink;
import de.mdelab.mlstorypatterns.MlstorypatternsFactory;
import de.mdelab.mlstorypatterns.StoryPattern;

/**
 * @generated
 */
public class ExpressionLinkCreateCommand extends EditElementCommand
{

	/**
	 * @generated
	 */
	private final EObject		source;

	/**
	 * @generated
	 */
	private final EObject		target;

	/**
	 * @generated
	 */
	private final StoryPattern	container;

	/**
	 * @generated
	 */
	public ExpressionLinkCreateCommand(CreateRelationshipRequest request, EObject source, EObject target)
	{
		super(request.getLabel(), null, request);
		this.source = source;
		this.target = target;
		container = deduceContainer(source, target);
	}

	/**
	 * @generated
	 */
	public boolean canExecute()
	{
		if (source == null && target == null)
		{
			return false;
		}
		if (source != null && false == source instanceof AbstractStoryPatternObject)
		{
			return false;
		}
		if (target != null && false == target instanceof AbstractStoryPatternObject)
		{
			return false;
		}
		if (getSource() == null)
		{
			return true; // link creation is in progress; source is not defined yet
		}
		// target may be null here but it's possible to check constraint
		if (getContainer() == null)
		{
			return false;
		}
		return MlsdmBaseItemSemanticEditPolicy.getLinkConstraints().canCreateExpressionLink_4004(getContainer(), getSource(), getTarget());
	}

	/**
	 * @generated
	 */
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor, IAdaptable info) throws ExecutionException
	{
		if (!canExecute())
		{
			throw new ExecutionException("Invalid arguments in create link command"); //$NON-NLS-1$
		}

		ExpressionLink newElement = MlstorypatternsFactory.eINSTANCE.createExpressionLink();
		getContainer().getStoryPatternLinks().add(newElement);
		newElement.setSource(getSource());
		newElement.setTarget(getTarget());
		doConfigure(newElement, monitor, info);
		((CreateElementRequest) getRequest()).setNewElement(newElement);
		return CommandResult.newOKCommandResult(newElement);

	}

	/**
	 * @generated
	 */
	protected void doConfigure(ExpressionLink newElement, IProgressMonitor monitor, IAdaptable info) throws ExecutionException
	{
		IElementType elementType = ((CreateElementRequest) getRequest()).getElementType();
		ConfigureRequest configureRequest = new ConfigureRequest(getEditingDomain(), newElement, elementType);
		configureRequest.setClientContext(((CreateElementRequest) getRequest()).getClientContext());
		configureRequest.addParameters(getRequest().getParameters());
		configureRequest.setParameter(CreateRelationshipRequest.SOURCE, getSource());
		configureRequest.setParameter(CreateRelationshipRequest.TARGET, getTarget());
		ICommand configureCommand = elementType.getEditCommand(configureRequest);
		if (configureCommand != null && configureCommand.canExecute())
		{
			configureCommand.execute(monitor, info);
		}
	}

	/**
	 * @generated
	 */
	protected void setElementToEdit(EObject element)
	{
		throw new UnsupportedOperationException();
	}

	/**
	 * @generated
	 */
	protected AbstractStoryPatternObject getSource()
	{
		return (AbstractStoryPatternObject) source;
	}

	/**
	 * @generated
	 */
	protected AbstractStoryPatternObject getTarget()
	{
		return (AbstractStoryPatternObject) target;
	}

	/**
	 * @generated
	 */
	public StoryPattern getContainer()
	{
		return container;
	}

	/**
	 * Default approach is to traverse ancestors of the source to find instance of container.
	 * Modify with appropriate logic.
	 * @generated
	 */
	private static StoryPattern deduceContainer(EObject source, EObject target)
	{
		// Find container element for the new link.
		// Climb up by containment hierarchy starting from the source
		// and return the first element that is instance of the container class.
		for (EObject element = source; element != null; element = element.eContainer())
		{
			if (element instanceof StoryPattern)
			{
				return (StoryPattern) element;
			}
		}
		return null;
	}

}
