package de.mdelab.mlsdm.diagram.edit.parts;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Connection;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.PolylineDecoration;
import org.eclipse.draw2d.RotatableDecoration;
import org.eclipse.gef.EditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ConnectionNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ITreeBranchEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.draw2d.ui.figures.PolylineConnectionEx;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.notation.View;

import de.mdelab.mlsdm.diagram.edit.policies.LinkOrderConstraintItemSemanticEditPolicy;

/**
 * @generated
 */
public class LinkOrderConstraintEditPart extends ConnectionNodeEditPart implements ITreeBranchEditPart
{

	/**
	 * @generated
	 */
	public static final int	VISUAL_ID	= 4005;

	/**
	 * @generated
	 */
	public LinkOrderConstraintEditPart(View view)
	{
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies()
	{
		super.createDefaultEditPolicies();
		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE, new LinkOrderConstraintItemSemanticEditPolicy());
	}

	/**
	 * @generated
	 */
	protected boolean addFixedChild(EditPart childEditPart)
	{
		if (childEditPart instanceof WrappingLabel15EditPart)
		{
			((WrappingLabel15EditPart) childEditPart).setLabel(getPrimaryShape().getFigureLinkOrderConstraintLabel());
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected void addChildVisual(EditPart childEditPart, int index)
	{
		if (addFixedChild(childEditPart))
		{
			return;
		}
		super.addChildVisual(childEditPart, index);
	}

	/**
	 * @generated
	 */
	protected boolean removeFixedChild(EditPart childEditPart)
	{
		if (childEditPart instanceof WrappingLabel15EditPart)
		{
			return true;
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected void removeChildVisual(EditPart childEditPart)
	{
		if (removeFixedChild(childEditPart))
		{
			return;
		}
		super.removeChildVisual(childEditPart);
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */

	protected Connection createConnectionFigure()
	{
		return new LinkOrderConstraintFigureDescriptor();
	}

	/**
	 * @generated
	 */
	public LinkOrderConstraintFigureDescriptor getPrimaryShape()
	{
		return (LinkOrderConstraintFigureDescriptor) getFigure();
	}

	/**
	 * @generated
	 */
	public class LinkOrderConstraintFigureDescriptor extends PolylineConnectionEx
	{

		/**
		 * @generated
		 */
		private WrappingLabel	fFigureLinkOrderConstraintLabel;

		/**
		 * @generated
		 */
		public LinkOrderConstraintFigureDescriptor()
		{
			this.setLineWidth(3);
			this.setLineStyle(Graphics.LINE_DOT);
			this.setForegroundColor(ColorConstants.black);

			createContents();
			setTargetDecoration(createTargetDecoration());
		}

		/**
		 * @generated
		 */
		private void createContents()
		{

			fFigureLinkOrderConstraintLabel = new WrappingLabel();

			fFigureLinkOrderConstraintLabel.setText("");
			fFigureLinkOrderConstraintLabel.setForegroundColor(ColorConstants.gray);

			this.add(fFigureLinkOrderConstraintLabel);

		}

		/**
		 * @generated
		 */
		private RotatableDecoration createTargetDecoration()
		{
			PolylineDecoration df = new PolylineDecoration();
			return df;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getFigureLinkOrderConstraintLabel()
		{
			return fFigureLinkOrderConstraintLabel;
		}

	}

}
