package de.mdelab.mlsdm.diagram.edit.parts;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.FreeformLayout;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.RoundedRectangle;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.XYLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.editpolicies.LayoutEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.editparts.IGraphicalEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ShapeNodeEditPart;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.DragDropEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.ResizableShapeEditPolicy;
import org.eclipse.gmf.runtime.diagram.ui.editpolicies.XYLayoutEditPolicy;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.gef.ui.figures.DefaultSizeNodeFigure;
import org.eclipse.gmf.runtime.gef.ui.figures.NodeFigure;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.gmf.tooling.runtime.edit.policies.reparent.CreationEditPolicyWithCustomReparent;
import org.eclipse.swt.graphics.Color;

import de.mdelab.mlsdm.diagram.edit.policies.StructuredNode2CanonicalEditPolicy;
import de.mdelab.mlsdm.diagram.edit.policies.StructuredNode2ItemSemanticEditPolicy;
import de.mdelab.mlsdm.diagram.part.MlsdmVisualIDRegistry;
import de.mdelab.mlsdm.diagram.providers.MlsdmElementTypes;

/**
 * @generated
 */
public class StructuredNode2EditPart extends ShapeNodeEditPart
{

	/**
	 * @generated
	 */
	public static final int	VISUAL_ID	= 3018;

	/**
	 * @generated
	 */
	protected IFigure		contentPane;

	/**
	 * @generated
	 */
	protected IFigure		primaryShape;

	/**
	 * @generated
	 */
	public StructuredNode2EditPart(View view)
	{
		super(view);
	}

	/**
	 * @generated
	 */
	protected void createDefaultEditPolicies()
	{
		installEditPolicy(EditPolicyRoles.CREATION_ROLE, new CreationEditPolicyWithCustomReparent(MlsdmVisualIDRegistry.TYPED_INSTANCE));
		super.createDefaultEditPolicies();
		installEditPolicy(EditPolicyRoles.SEMANTIC_ROLE, new StructuredNode2ItemSemanticEditPolicy());
		installEditPolicy(EditPolicyRoles.DRAG_DROP_ROLE, new DragDropEditPolicy());
		installEditPolicy(EditPolicyRoles.CANONICAL_ROLE, new StructuredNode2CanonicalEditPolicy());
		installEditPolicy(EditPolicy.LAYOUT_ROLE, createLayoutEditPolicy());
		// XXX need an SCR to runtime to have another abstract superclass that would let children add reasonable editpolicies
		// removeEditPolicy(org.eclipse.gmf.runtime.diagram.ui.editpolicies.EditPolicyRoles.CONNECTION_HANDLES_ROLE);
	}

	/**
	 * @generated
	 */
	protected LayoutEditPolicy createLayoutEditPolicy()
	{
		XYLayoutEditPolicy lep = new XYLayoutEditPolicy()
		{

			protected EditPolicy createChildEditPolicy(EditPart child)
			{
				EditPolicy result = super.createChildEditPolicy(child);
				if (result == null)
				{
					return new ResizableShapeEditPolicy();
				}
				return result;
			}
		};
		return lep;
	}

	/**
	 * @generated
	 */
	protected IFigure createNodeShape()
	{
		return primaryShape = new StructuredNodeFigureDescriptor()
		{
			protected boolean useLocalCoordinates()
			{
				return true;
			}
		};
	}

	/**
	 * @generated
	 */
	public StructuredNodeFigureDescriptor getPrimaryShape()
	{
		return (StructuredNodeFigureDescriptor) primaryShape;
	}

	/**
	 * @generated
	 */
	protected NodeFigure createNodePlate()
	{
		DefaultSizeNodeFigure result = new DefaultSizeNodeFigure(40, 40);
		return result;
	}

	/**
	 * Creates figure for this edit part.
	 * 
	 * Body of this method does not depend on settings in generation model
	 * so you may safely remove <i>generated</i> tag and modify it.
	 * 
	 * @generated
	 */
	protected NodeFigure createNodeFigure()
	{
		NodeFigure figure = createNodePlate();
		figure.setLayoutManager(new StackLayout());
		IFigure shape = createNodeShape();
		figure.add(shape);
		contentPane = setupContentPane(shape);
		return figure;
	}

	/**
	 * Default implementation treats passed figure as content pane.
	 * Respects layout one may have set for generated figure.
	 * @param nodeShape instance of generated figure class
	 * @generated
	 */
	protected IFigure setupContentPane(IFigure nodeShape)
	{
		if (nodeShape.getLayoutManager() == null)
		{
			nodeShape.setLayoutManager(new FreeformLayout()
			{

				public Object getConstraint(IFigure figure)
				{
					Object result = constraints.get(figure);
					if (result == null)
					{
						result = new Rectangle(0, 0, -1, -1);
					}
					return result;
				}
			});
		}
		return nodeShape; // use nodeShape itself as contentPane
	}

	/**
	 * @generated
	 */
	public IFigure getContentPane()
	{
		if (contentPane != null)
		{
			return contentPane;
		}
		return super.getContentPane();
	}

	/**
	 * @generated
	 */
	protected void setForegroundColor(Color color)
	{
		if (primaryShape != null)
		{
			primaryShape.setForegroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setBackgroundColor(Color color)
	{
		if (primaryShape != null)
		{
			primaryShape.setBackgroundColor(color);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineWidth(int width)
	{
		if (primaryShape instanceof Shape)
		{
			((Shape) primaryShape).setLineWidth(width);
		}
	}

	/**
	 * @generated
	 */
	protected void setLineType(int style)
	{
		if (primaryShape instanceof Shape)
		{
			((Shape) primaryShape).setLineStyle(style);
		}
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSource()
	{
		ArrayList<IElementType> types = new ArrayList<IElementType>(1);
		types.add(MlsdmElementTypes.ActivityEdge_4001);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnSourceAndTarget(IGraphicalEditPart targetEditPart)
	{
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (targetEditPart instanceof ActivityFinalNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof DecisionMergeNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof ExpressionActivityNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof FlowFinalNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof ForkJoinNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof InitialNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof StoryNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof StructuredNodeEditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof DecisionMergeNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof ExpressionActivityNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof FlowFinalNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof ForkJoinNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof InitialNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof StoryNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof de.mdelab.mlsdm.diagram.edit.parts.StructuredNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		if (targetEditPart instanceof ActivityFinalNode2EditPart)
		{
			types.add(MlsdmElementTypes.ActivityEdge_4001);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForTarget(IElementType relationshipType)
	{
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == MlsdmElementTypes.ActivityEdge_4001)
		{
			types.add(MlsdmElementTypes.ActivityFinalNode_2002);
			types.add(MlsdmElementTypes.DecisionMergeNode_2006);
			types.add(MlsdmElementTypes.ExpressionActivityNode_2001);
			types.add(MlsdmElementTypes.FlowFinalNode_2007);
			types.add(MlsdmElementTypes.ForkJoinNode_2003);
			types.add(MlsdmElementTypes.InitialNode_2004);
			types.add(MlsdmElementTypes.StoryNode_2008);
			types.add(MlsdmElementTypes.StructuredNode_2009);
			types.add(MlsdmElementTypes.DecisionMergeNode_3006);
			types.add(MlsdmElementTypes.ExpressionActivityNode_3007);
			types.add(MlsdmElementTypes.FlowFinalNode_3008);
			types.add(MlsdmElementTypes.ForkJoinNode_3009);
			types.add(MlsdmElementTypes.InitialNode_3010);
			types.add(MlsdmElementTypes.StoryNode_3011);
			types.add(MlsdmElementTypes.StructuredNode_3018);
			types.add(MlsdmElementTypes.ActivityFinalNode_3019);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMARelTypesOnTarget()
	{
		ArrayList<IElementType> types = new ArrayList<IElementType>(1);
		types.add(MlsdmElementTypes.ActivityEdge_4001);
		return types;
	}

	/**
	 * @generated
	 */
	public List<IElementType> getMATypesForSource(IElementType relationshipType)
	{
		LinkedList<IElementType> types = new LinkedList<IElementType>();
		if (relationshipType == MlsdmElementTypes.ActivityEdge_4001)
		{
			types.add(MlsdmElementTypes.ActivityFinalNode_2002);
			types.add(MlsdmElementTypes.DecisionMergeNode_2006);
			types.add(MlsdmElementTypes.ExpressionActivityNode_2001);
			types.add(MlsdmElementTypes.FlowFinalNode_2007);
			types.add(MlsdmElementTypes.ForkJoinNode_2003);
			types.add(MlsdmElementTypes.InitialNode_2004);
			types.add(MlsdmElementTypes.StoryNode_2008);
			types.add(MlsdmElementTypes.StructuredNode_2009);
			types.add(MlsdmElementTypes.DecisionMergeNode_3006);
			types.add(MlsdmElementTypes.ExpressionActivityNode_3007);
			types.add(MlsdmElementTypes.FlowFinalNode_3008);
			types.add(MlsdmElementTypes.ForkJoinNode_3009);
			types.add(MlsdmElementTypes.InitialNode_3010);
			types.add(MlsdmElementTypes.StoryNode_3011);
			types.add(MlsdmElementTypes.StructuredNode_3018);
			types.add(MlsdmElementTypes.ActivityFinalNode_3019);
		}
		return types;
	}

	/**
	 * @generated
	 */
	public class StructuredNodeFigureDescriptor extends RoundedRectangle
	{

		/**
		 * @generated
		 */
		public StructuredNodeFigureDescriptor()
		{
			this.setLayoutManager(new XYLayout());
			this.setCornerDimensions(new Dimension(getMapMode().DPtoLP(8), getMapMode().DPtoLP(8)));
			this.setLineWidth(2);
			this.setLineStyle(Graphics.LINE_DASH);
			this.setForegroundColor(ColorConstants.black);
			this.setMinimumSize(new Dimension(getMapMode().DPtoLP(100), getMapMode().DPtoLP(100)));
		}

	}

}
