package de.mdelab.mlsdm.diagram.navigator;

import org.eclipse.gmf.runtime.common.ui.services.parser.CommonParserHint;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserOptions;
import org.eclipse.gmf.runtime.emf.core.util.EObjectAdapter;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.jface.viewers.ITreePathLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TreePath;
import org.eclipse.jface.viewers.ViewerLabel;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonLabelProvider;

import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.DecisionMergeNode;
import de.mdelab.mlsdm.FlowFinalNode;
import de.mdelab.mlsdm.ForkJoinNode;
import de.mdelab.mlsdm.StructuredNode;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityEdgeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityFinalNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.AttributeAssignmentEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ContainmentLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.DecisionMergeNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.DecisionMergeNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionActivityNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionActivityNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionActivityNodeName2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionActivityNodeNameEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.FlowFinalNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.FlowFinalNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ForkJoinNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ForkJoinNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.InitialNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.InitialNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.LinkOrderConstraintEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MLStringExpression2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MLStringExpressionEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MapEntryLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MapEntryLinkValueTargetEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryNodeName2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryNodeNameEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternObjectEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternObjectNameEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StructuredNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel10EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel13EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel15EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel4EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel7EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabel9EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.WrappingLabelEditPart;
import de.mdelab.mlsdm.diagram.part.MlsdmDiagramEditorPlugin;
import de.mdelab.mlsdm.diagram.part.MlsdmVisualIDRegistry;
import de.mdelab.mlsdm.diagram.providers.MlsdmElementTypes;
import de.mdelab.mlsdm.diagram.providers.MlsdmParserProvider;
import de.mdelab.mlstorypatterns.ContainmentLink;
import de.mdelab.mlstorypatterns.LinkOrderConstraint;
import de.mdelab.mlstorypatterns.StoryPattern;

/**
 * @generated
 */
public class MlsdmNavigatorLabelProvider extends LabelProvider implements
		ICommonLabelProvider, ITreePathLabelProvider {

	/**
	 * @generated
	 */
	static {
		MlsdmDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?UnknownElement", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
		MlsdmDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put("Navigator?ImageNotFound", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	public void updateLabel(ViewerLabel label, TreePath elementPath) {
		Object element = elementPath.getLastSegment();
		if (element instanceof MlsdmNavigatorItem
				&& !isOwnView(((MlsdmNavigatorItem) element).getView())) {
			return;
		}
		label.setText(getText(element));
		label.setImage(getImage(element));
	}

	/**
	 * @generated
	 */
	public Image getImage(Object element) {
		if (element instanceof MlsdmNavigatorGroup) {
			MlsdmNavigatorGroup group = (MlsdmNavigatorGroup) element;
			return MlsdmDiagramEditorPlugin.getInstance().getBundledImage(
					group.getIcon());
		}

		if (element instanceof MlsdmNavigatorItem) {
			MlsdmNavigatorItem navigatorItem = (MlsdmNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return super.getImage(element);
			}
			return getImage(navigatorItem.getView());
		}

		return super.getImage(element);
	}

	/**
	 * @generated
	 */
	public Image getImage(View view) {
		switch (MlsdmVisualIDRegistry.getVisualID(view)) {
		case DecisionMergeNodeEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://www.mdelab.de/mlsdm/1.0?DecisionMergeNode", MlsdmElementTypes.DecisionMergeNode_2006); //$NON-NLS-1$
		case DecisionMergeNode2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://www.mdelab.de/mlsdm/1.0?DecisionMergeNode", MlsdmElementTypes.DecisionMergeNode_3006); //$NON-NLS-1$
		case StoryPatternEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://www.mdelab.de/mlstorypatterns/1.0?StoryPattern", MlsdmElementTypes.StoryPattern_3002); //$NON-NLS-1$
		case ExpressionActivityNode2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://www.mdelab.de/mlsdm/1.0?ExpressionActivityNode", MlsdmElementTypes.ExpressionActivityNode_3007); //$NON-NLS-1$
		case StructuredNodeEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://www.mdelab.de/mlsdm/1.0?StructuredNode", MlsdmElementTypes.StructuredNode_2009); //$NON-NLS-1$
		case LinkOrderConstraintEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://www.mdelab.de/mlstorypatterns/1.0?LinkOrderConstraint", MlsdmElementTypes.LinkOrderConstraint_4005); //$NON-NLS-1$
		case InitialNode2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://www.mdelab.de/mlsdm/1.0?InitialNode", MlsdmElementTypes.InitialNode_3010); //$NON-NLS-1$
		case MLStringExpression2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://www.mdelab.de/mlexpressions/1.0?MLStringExpression", MlsdmElementTypes.MLStringExpression_3004); //$NON-NLS-1$
		case StoryNodeEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://www.mdelab.de/mlsdm/1.0?StoryNode", MlsdmElementTypes.StoryNode_2008); //$NON-NLS-1$
		case StoryNode2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://www.mdelab.de/mlsdm/1.0?StoryNode", MlsdmElementTypes.StoryNode_3011); //$NON-NLS-1$
		case ContainmentLinkEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://www.mdelab.de/mlstorypatterns/1.0?ContainmentLink", MlsdmElementTypes.ContainmentLink_4003); //$NON-NLS-1$
		case ExpressionLinkEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://www.mdelab.de/mlstorypatterns/1.0?ExpressionLink", MlsdmElementTypes.ExpressionLink_4004); //$NON-NLS-1$
		case StoryPatternLinkEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://www.mdelab.de/mlstorypatterns/1.0?StoryPatternLink", MlsdmElementTypes.StoryPatternLink_4002); //$NON-NLS-1$
		case ExpressionActivityNodeEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://www.mdelab.de/mlsdm/1.0?ExpressionActivityNode", MlsdmElementTypes.ExpressionActivityNode_2001); //$NON-NLS-1$
		case FlowFinalNode2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://www.mdelab.de/mlsdm/1.0?FlowFinalNode", MlsdmElementTypes.FlowFinalNode_3008); //$NON-NLS-1$
		case StoryPatternObjectEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://www.mdelab.de/mlstorypatterns/1.0?StoryPatternObject", MlsdmElementTypes.StoryPatternObject_3003); //$NON-NLS-1$
		case ForkJoinNodeEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://www.mdelab.de/mlsdm/1.0?ForkJoinNode", MlsdmElementTypes.ForkJoinNode_2003); //$NON-NLS-1$
		case InitialNodeEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://www.mdelab.de/mlsdm/1.0?InitialNode", MlsdmElementTypes.InitialNode_2004); //$NON-NLS-1$
		case AttributeAssignmentEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://www.mdelab.de/mlstorypatterns/1.0?AttributeAssignment", MlsdmElementTypes.AttributeAssignment_3005); //$NON-NLS-1$
		case MLStringExpressionEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://www.mdelab.de/mlexpressions/1.0?MLStringExpression", MlsdmElementTypes.MLStringExpression_3001); //$NON-NLS-1$
		case MapEntryLinkValueTargetEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://www.mdelab.de/mlstorypatterns/1.0?MapEntryLink?valueTarget", MlsdmElementTypes.MapEntryLinkValueTarget_4007); //$NON-NLS-1$
		case ActivityEdgeEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://www.mdelab.de/mlsdm/1.0?ActivityEdge", MlsdmElementTypes.ActivityEdge_4001); //$NON-NLS-1$
		case ActivityFinalNodeEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://www.mdelab.de/mlsdm/1.0?ActivityFinalNode", MlsdmElementTypes.ActivityFinalNode_2002); //$NON-NLS-1$
		case MapEntryLinkEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?http://www.mdelab.de/mlstorypatterns/1.0?MapEntryLink", MlsdmElementTypes.MapEntryLink_4006); //$NON-NLS-1$
		case ActivityEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Diagram?http://www.mdelab.de/mlsdm/1.0?Activity", MlsdmElementTypes.Activity_1000); //$NON-NLS-1$
		case ForkJoinNode2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?http://www.mdelab.de/mlsdm/1.0?ForkJoinNode", MlsdmElementTypes.ForkJoinNode_3009); //$NON-NLS-1$
		case FlowFinalNodeEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?http://www.mdelab.de/mlsdm/1.0?FlowFinalNode", MlsdmElementTypes.FlowFinalNode_2007); //$NON-NLS-1$
		}
		return getImage("Navigator?UnknownElement", null); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private Image getImage(String key, IElementType elementType) {
		ImageRegistry imageRegistry = MlsdmDiagramEditorPlugin.getInstance()
				.getImageRegistry();
		Image image = imageRegistry.get(key);
		if (image == null && elementType != null
				&& MlsdmElementTypes.isKnownElementType(elementType)) {
			image = MlsdmElementTypes.getImage(elementType);
			imageRegistry.put(key, image);
		}

		if (image == null) {
			image = imageRegistry.get("Navigator?ImageNotFound"); //$NON-NLS-1$
			imageRegistry.put(key, image);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public String getText(Object element) {
		if (element instanceof MlsdmNavigatorGroup) {
			MlsdmNavigatorGroup group = (MlsdmNavigatorGroup) element;
			return group.getGroupName();
		}

		if (element instanceof MlsdmNavigatorItem) {
			MlsdmNavigatorItem navigatorItem = (MlsdmNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return null;
			}
			return getText(navigatorItem.getView());
		}

		return super.getText(element);
	}

	/**
	 * @generated
	 */
	public String getText(View view) {
		if (view.getElement() != null && view.getElement().eIsProxy()) {
			return getUnresolvedDomainElementProxyText(view);
		}
		switch (MlsdmVisualIDRegistry.getVisualID(view)) {
		case DecisionMergeNodeEditPart.VISUAL_ID:
			return getDecisionMergeNode_2006Text(view);
		case DecisionMergeNode2EditPart.VISUAL_ID:
			return getDecisionMergeNode_3006Text(view);
		case StoryPatternEditPart.VISUAL_ID:
			return getStoryPattern_3002Text(view);
		case ExpressionActivityNode2EditPart.VISUAL_ID:
			return getExpressionActivityNode_3007Text(view);
		case StructuredNodeEditPart.VISUAL_ID:
			return getStructuredNode_2009Text(view);
		case LinkOrderConstraintEditPart.VISUAL_ID:
			return getLinkOrderConstraint_4005Text(view);
		case InitialNode2EditPart.VISUAL_ID:
			return getInitialNode_3010Text(view);
		case MLStringExpression2EditPart.VISUAL_ID:
			return getMLStringExpression_3004Text(view);
		case StoryNodeEditPart.VISUAL_ID:
			return getStoryNode_2008Text(view);
		case StoryNode2EditPart.VISUAL_ID:
			return getStoryNode_3011Text(view);
		case ContainmentLinkEditPart.VISUAL_ID:
			return getContainmentLink_4003Text(view);
		case ExpressionLinkEditPart.VISUAL_ID:
			return getExpressionLink_4004Text(view);
		case StoryPatternLinkEditPart.VISUAL_ID:
			return getStoryPatternLink_4002Text(view);
		case ExpressionActivityNodeEditPart.VISUAL_ID:
			return getExpressionActivityNode_2001Text(view);
		case FlowFinalNode2EditPart.VISUAL_ID:
			return getFlowFinalNode_3008Text(view);
		case StoryPatternObjectEditPart.VISUAL_ID:
			return getStoryPatternObject_3003Text(view);
		case ForkJoinNodeEditPart.VISUAL_ID:
			return getForkJoinNode_2003Text(view);
		case InitialNodeEditPart.VISUAL_ID:
			return getInitialNode_2004Text(view);
		case AttributeAssignmentEditPart.VISUAL_ID:
			return getAttributeAssignment_3005Text(view);
		case MLStringExpressionEditPart.VISUAL_ID:
			return getMLStringExpression_3001Text(view);
		case MapEntryLinkValueTargetEditPart.VISUAL_ID:
			return getMapEntryLinkValueTarget_4007Text(view);
		case ActivityEdgeEditPart.VISUAL_ID:
			return getActivityEdge_4001Text(view);
		case ActivityFinalNodeEditPart.VISUAL_ID:
			return getActivityFinalNode_2002Text(view);
		case MapEntryLinkEditPart.VISUAL_ID:
			return getMapEntryLink_4006Text(view);
		case ActivityEditPart.VISUAL_ID:
			return getActivity_1000Text(view);
		case ForkJoinNode2EditPart.VISUAL_ID:
			return getForkJoinNode_3009Text(view);
		case FlowFinalNodeEditPart.VISUAL_ID:
			return getFlowFinalNode_2007Text(view);
		}
		return getUnknownElementText(view);
	}

	/**
	 * @generated
	 */
	private String getActivityEdge_4001Text(View view) {
		IParser parser = MlsdmParserProvider
				.getParser(MlsdmElementTypes.ActivityEdge_4001, view
						.getElement() != null ? view.getElement() : view,
						MlsdmVisualIDRegistry
								.getType(WrappingLabel4EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			MlsdmDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 6001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getDecisionMergeNode_3006Text(View view) {
		DecisionMergeNode domainModelElement = (DecisionMergeNode) view
				.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getUuid();
		} else {
			MlsdmDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 3006); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getExpressionLink_4004Text(View view) {
		IParser parser = MlsdmParserProvider
				.getParser(MlsdmElementTypes.ExpressionLink_4004, view
						.getElement() != null ? view.getElement() : view,
						MlsdmVisualIDRegistry
								.getType(WrappingLabel9EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			MlsdmDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 6004); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getLinkOrderConstraint_4005Text(View view) {
		IParser parser = MlsdmParserProvider.getParser(
				MlsdmElementTypes.LinkOrderConstraint_4005,
				view.getElement() != null ? view.getElement() : view,
				MlsdmVisualIDRegistry
						.getType(WrappingLabel15EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			MlsdmDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 6008); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getMapEntryLink_4006Text(View view) {
		IParser parser = MlsdmParserProvider.getParser(
				MlsdmElementTypes.MapEntryLink_4006,
				view.getElement() != null ? view.getElement() : view,
				MlsdmVisualIDRegistry
						.getType(WrappingLabel10EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			MlsdmDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 6005); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getContainmentLink_4003Text(View view) {
		ContainmentLink domainModelElement = (ContainmentLink) view
				.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getUuid();
		} else {
			MlsdmDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 4003); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getExpressionActivityNode_3007Text(View view) {
		IParser parser = MlsdmParserProvider
				.getParser(
						MlsdmElementTypes.ExpressionActivityNode_3007,
						view.getElement() != null ? view.getElement() : view,
						MlsdmVisualIDRegistry
								.getType(ExpressionActivityNodeName2EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			MlsdmDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5009); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getActivityFinalNode_2002Text(View view) {
		IParser parser = MlsdmParserProvider.getParser(
				MlsdmElementTypes.ActivityFinalNode_2002,
				view.getElement() != null ? view.getElement() : view,
				MlsdmVisualIDRegistry.getType(WrappingLabelEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			MlsdmDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getInitialNode_2004Text(View view) {
		IParser parser = MlsdmParserProvider
				.getParser(MlsdmElementTypes.InitialNode_2004, view
						.getElement() != null ? view.getElement() : view,
						MlsdmVisualIDRegistry
								.getType(WrappingLabel2EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			MlsdmDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5003); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getStoryPattern_3002Text(View view) {
		StoryPattern domainModelElement = (StoryPattern) view.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getName();
		} else {
			MlsdmDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 3002); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getStoryNode_2008Text(View view) {
		IParser parser = MlsdmParserProvider.getParser(
				MlsdmElementTypes.StoryNode_2008,
				view.getElement() != null ? view.getElement() : view,
				MlsdmVisualIDRegistry.getType(StoryNodeNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			MlsdmDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5005); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getStoryPatternLink_4002Text(View view) {
		IParser parser = MlsdmParserProvider
				.getParser(MlsdmElementTypes.StoryPatternLink_4002, view
						.getElement() != null ? view.getElement() : view,
						MlsdmVisualIDRegistry
								.getType(WrappingLabel7EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			MlsdmDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 6002); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getInitialNode_3010Text(View view) {
		IParser parser = MlsdmParserProvider.getParser(
				MlsdmElementTypes.InitialNode_3010,
				view.getElement() != null ? view.getElement() : view,
				MlsdmVisualIDRegistry
						.getType(WrappingLabel13EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			MlsdmDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5010); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getMLStringExpression_3001Text(View view) {
		IParser parser = MlsdmParserProvider.getParser(
				MlsdmElementTypes.MLStringExpression_3001,
				view.getElement() != null ? view.getElement() : view,
				MlsdmVisualIDRegistry
						.getType(MLStringExpressionEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			MlsdmDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 3001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getStoryNode_3011Text(View view) {
		IParser parser = MlsdmParserProvider
				.getParser(MlsdmElementTypes.StoryNode_3011,
						view.getElement() != null ? view.getElement() : view,
						MlsdmVisualIDRegistry
								.getType(StoryNodeName2EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			MlsdmDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5012); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getForkJoinNode_2003Text(View view) {
		ForkJoinNode domainModelElement = (ForkJoinNode) view.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getUuid();
		} else {
			MlsdmDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 2003); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getFlowFinalNode_2007Text(View view) {
		FlowFinalNode domainModelElement = (FlowFinalNode) view.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getUuid();
		} else {
			MlsdmDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 2007); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getStructuredNode_2009Text(View view) {
		StructuredNode domainModelElement = (StructuredNode) view.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getUuid();
		} else {
			MlsdmDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 2009); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getStoryPatternObject_3003Text(View view) {
		IParser parser = MlsdmParserProvider.getParser(
				MlsdmElementTypes.StoryPatternObject_3003,
				view.getElement() != null ? view.getElement() : view,
				MlsdmVisualIDRegistry
						.getType(StoryPatternObjectNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			MlsdmDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5006); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getAttributeAssignment_3005Text(View view) {
		IParser parser = MlsdmParserProvider.getParser(
				MlsdmElementTypes.AttributeAssignment_3005,
				view.getElement() != null ? view.getElement() : view,
				MlsdmVisualIDRegistry
						.getType(AttributeAssignmentEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			MlsdmDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 3005); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getMapEntryLinkValueTarget_4007Text(View view) {
		IParser parser = MlsdmParserProvider.getParser(
				MlsdmElementTypes.MapEntryLinkValueTarget_4007,
				view.getElement() != null ? view.getElement() : view,
				CommonParserHint.DESCRIPTION);
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			MlsdmDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 6007); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getFlowFinalNode_3008Text(View view) {
		FlowFinalNode domainModelElement = (FlowFinalNode) view.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getUuid();
		} else {
			MlsdmDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 3008); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getDecisionMergeNode_2006Text(View view) {
		DecisionMergeNode domainModelElement = (DecisionMergeNode) view
				.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getUuid();
		} else {
			MlsdmDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 2006); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getExpressionActivityNode_2001Text(View view) {
		IParser parser = MlsdmParserProvider.getParser(
				MlsdmElementTypes.ExpressionActivityNode_2001, view
						.getElement() != null ? view.getElement() : view,
				MlsdmVisualIDRegistry
						.getType(ExpressionActivityNodeNameEditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			MlsdmDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 5002); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getForkJoinNode_3009Text(View view) {
		ForkJoinNode domainModelElement = (ForkJoinNode) view.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getUuid();
		} else {
			MlsdmDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 3009); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getMLStringExpression_3004Text(View view) {
		IParser parser = MlsdmParserProvider.getParser(
				MlsdmElementTypes.MLStringExpression_3004,
				view.getElement() != null ? view.getElement() : view,
				MlsdmVisualIDRegistry
						.getType(MLStringExpression2EditPart.VISUAL_ID));
		if (parser != null) {
			return parser.getPrintString(new EObjectAdapter(
					view.getElement() != null ? view.getElement() : view),
					ParserOptions.NONE.intValue());
		} else {
			MlsdmDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 3004); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getActivity_1000Text(View view) {
		Activity domainModelElement = (Activity) view.getElement();
		if (domainModelElement != null) {
			return domainModelElement.getName();
		} else {
			MlsdmDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 1000); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getUnknownElementText(View view) {
		return "<UnknownElement Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	private String getUnresolvedDomainElementProxyText(View view) {
		return "<Unresolved domain element Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$  //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public String getDescription(Object anElement) {
		return null;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return ActivityEditPart.MODEL_ID.equals(MlsdmVisualIDRegistry
				.getModelID(view));
	}

}
