package de.mdelab.mlsdm.diagram.part;

import java.lang.reflect.InvocationTargetException;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.jface.dialogs.ErrorDialog;
import org.eclipse.jface.operation.IRunnableWithProgress;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.ui.INewWizard;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.actions.WorkspaceModifyOperation;

/**
 * @generated
 */
public class MlsdmCreationWizard extends Wizard implements INewWizard
{

	/**
	 * @generated
	 */
	private IWorkbench					workbench;

	/**
	 * @generated
	 */
	protected IStructuredSelection		selection;

	/**
	 * @generated
	 */
	protected MlsdmCreationWizardPage	diagramModelFilePage;

	/**
	 * @generated
	 */
	protected MlsdmCreationWizardPage	domainModelFilePage;

	/**
	 * @generated
	 */
	protected Resource					diagram;

	/**
	 * @generated
	 */
	private boolean						openNewlyCreatedDiagramEditor	= true;

	/**
	 * @generated
	 */
	public IWorkbench getWorkbench()
	{
		return workbench;
	}

	/**
	 * @generated
	 */
	public IStructuredSelection getSelection()
	{
		return selection;
	}

	/**
	 * @generated
	 */
	public final Resource getDiagram()
	{
		return diagram;
	}

	/**
	 * @generated
	 */
	public final boolean isOpenNewlyCreatedDiagramEditor()
	{
		return openNewlyCreatedDiagramEditor;
	}

	/**
	 * @generated
	 */
	public void setOpenNewlyCreatedDiagramEditor(boolean openNewlyCreatedDiagramEditor)
	{
		this.openNewlyCreatedDiagramEditor = openNewlyCreatedDiagramEditor;
	}

	/**
	 * @generated
	 */
	public void init(IWorkbench workbench, IStructuredSelection selection)
	{
		this.workbench = workbench;
		this.selection = selection;
		setWindowTitle(Messages.MlsdmCreationWizardTitle);
		setDefaultPageImageDescriptor(MlsdmDiagramEditorPlugin.getBundledImageDescriptor("icons/wizban/NewMlsdmWizard.gif")); //$NON-NLS-1$
		setNeedsProgressMonitor(true);
	}

	/**
	 * @generated
	 */
	public void addPages()
	{
		diagramModelFilePage = new MlsdmCreationWizardPage("DiagramModelFile", getSelection(), "mlsdm_diagram"); //$NON-NLS-1$ //$NON-NLS-2$
		diagramModelFilePage.setTitle(Messages.MlsdmCreationWizard_DiagramModelFilePageTitle);
		diagramModelFilePage.setDescription(Messages.MlsdmCreationWizard_DiagramModelFilePageDescription);
		addPage(diagramModelFilePage);

		domainModelFilePage = new MlsdmCreationWizardPage("DomainModelFile", getSelection(), "mlsdm") { //$NON-NLS-1$ //$NON-NLS-2$

			public void setVisible(boolean visible)
			{
				if (visible)
				{
					String fileName = diagramModelFilePage.getFileName();
					fileName = fileName.substring(0, fileName.length() - ".mlsdm_diagram".length()); //$NON-NLS-1$
					setFileName(MlsdmDiagramEditorUtil.getUniqueFileName(getContainerFullPath(), fileName, "mlsdm")); //$NON-NLS-1$
				}
				super.setVisible(visible);
			}
		};
		domainModelFilePage.setTitle(Messages.MlsdmCreationWizard_DomainModelFilePageTitle);
		domainModelFilePage.setDescription(Messages.MlsdmCreationWizard_DomainModelFilePageDescription);
		addPage(domainModelFilePage);
	}

	/**
	 * @generated
	 */
	public boolean performFinish()
	{
		IRunnableWithProgress op = new WorkspaceModifyOperation(null)
		{

			protected void execute(IProgressMonitor monitor) throws CoreException, InterruptedException
			{
				diagram = MlsdmDiagramEditorUtil.createDiagram(diagramModelFilePage.getURI(), domainModelFilePage.getURI(), monitor);
				if (isOpenNewlyCreatedDiagramEditor() && diagram != null)
				{
					try
					{
						MlsdmDiagramEditorUtil.openDiagram(diagram);
					}
					catch (PartInitException e)
					{
						ErrorDialog.openError(getContainer().getShell(), Messages.MlsdmCreationWizardOpenEditorError, null, e.getStatus());
					}
				}
			}
		};
		try
		{
			getContainer().run(false, true, op);
		}
		catch (InterruptedException e)
		{
			return false;
		}
		catch (InvocationTargetException e)
		{
			if (e.getTargetException() instanceof CoreException)
			{
				ErrorDialog.openError(getContainer().getShell(), Messages.MlsdmCreationWizardCreationError, null,
						((CoreException) e.getTargetException()).getStatus());
			}
			else
			{
				MlsdmDiagramEditorPlugin.getInstance().logError("Error creating diagram", e.getTargetException()); //$NON-NLS-1$
			}
			return false;
		}
		return diagram != null;
	}
}
