package de.mdelab.mlsdm.diagram.part;

import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.gmf.runtime.notation.View;

import org.eclipse.gmf.tooling.runtime.update.DiagramUpdater;
import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityFinalNode;
import de.mdelab.mlsdm.ActivityNode;
import de.mdelab.mlsdm.ActivityNodeContainer;
import de.mdelab.mlsdm.DecisionMergeNode;
import de.mdelab.mlsdm.ExpressionActivityNode;
import de.mdelab.mlsdm.FlowFinalNode;
import de.mdelab.mlsdm.ForkJoinNode;
import de.mdelab.mlsdm.InitialNode;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.StoryNode;
import de.mdelab.mlsdm.StructuredNode;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityEdgeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityFinalNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ActivityFinalNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.AttributeAssignmentEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.CallActionExpression2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.CallActionExpression3EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.CallActionExpressionEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ContainmentLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.DecisionMergeNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.DecisionMergeNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionActivityNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionActivityNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionActivityNodeExpressionFigureCompartment2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionActivityNodeExpressionFigureCompartmentEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ExpressionLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.FlowFinalNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.FlowFinalNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ForkJoinNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.ForkJoinNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.InitialNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.InitialNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.LinkOrderConstraintEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MLStringExpression2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MLStringExpression3EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MLStringExpressionEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MapEntryLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.MapEntryLinkValueTargetEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryNodeEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryNodeStoryNodeElementsCompartment2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryNodeStoryNodeElementsCompartmentEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPattern2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternLinkEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternObjectEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternObjectStoryPatternObjectAttributeAssignmentsCompartmentEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternObjectStoryPatternObjectConstraintsCompartmentEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternStoryPatternConstraintsCompartment2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternStoryPatternConstraintsCompartmentEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternStoryPatternElementsCompartment2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StoryPatternStoryPatternElementsCompartmentEditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StructuredNode2EditPart;
import de.mdelab.mlsdm.diagram.edit.parts.StructuredNodeEditPart;
import de.mdelab.mlsdm.diagram.providers.MlsdmElementTypes;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.AttributeAssignment;
import de.mdelab.mlstorypatterns.ContainmentLink;
import de.mdelab.mlstorypatterns.ExpressionLink;
import de.mdelab.mlstorypatterns.LinkOrderConstraint;
import de.mdelab.mlstorypatterns.MapEntryLink;
import de.mdelab.mlstorypatterns.MlstorypatternsPackage;
import de.mdelab.mlstorypatterns.StoryPattern;
import de.mdelab.mlstorypatterns.StoryPatternLink;
import de.mdelab.mlstorypatterns.StoryPatternObject;

/**
 * @generated
 */
public class MlsdmDiagramUpdater
{

	/**
	 * @generated
	 */
	public static List<MlsdmNodeDescriptor> getSemanticChildren(View view)
	{
		switch (MlsdmVisualIDRegistry.getVisualID(view))
		{
			case ActivityEditPart.VISUAL_ID:
				return getActivity_1000SemanticChildren(view);
			case StructuredNodeEditPart.VISUAL_ID:
				return getStructuredNode_2009SemanticChildren(view);
			case StructuredNode2EditPart.VISUAL_ID:
				return getStructuredNode_3018SemanticChildren(view);
			case ExpressionActivityNodeExpressionFigureCompartmentEditPart.VISUAL_ID:
				return getExpressionActivityNodeExpressionFigureCompartment_7001SemanticChildren(view);
			case StoryNodeStoryNodeElementsCompartmentEditPart.VISUAL_ID:
				return getStoryNodeStoryNodeElementsCompartment_7009SemanticChildren(view);
			case StoryPatternStoryPatternElementsCompartmentEditPart.VISUAL_ID:
				return getStoryPatternStoryPatternElementsCompartment_7011SemanticChildren(view);
			case StoryPatternStoryPatternConstraintsCompartmentEditPart.VISUAL_ID:
				return getStoryPatternStoryPatternConstraintsCompartment_7012SemanticChildren(view);
			case StoryPatternObjectStoryPatternObjectConstraintsCompartmentEditPart.VISUAL_ID:
				return getStoryPatternObjectStoryPatternObjectConstraintsCompartment_7003SemanticChildren(view);
			case StoryPatternObjectStoryPatternObjectAttributeAssignmentsCompartmentEditPart.VISUAL_ID:
				return getStoryPatternObjectStoryPatternObjectAttributeAssignmentsCompartment_7004SemanticChildren(view);
			case StoryPatternStoryPatternElementsCompartment2EditPart.VISUAL_ID:
				return getStoryPatternNegativeStoryPatternElementsCompartment_7015SemanticChildren(view);
			case StoryPatternStoryPatternConstraintsCompartment2EditPart.VISUAL_ID:
				return getStoryPatternNegativeStoryPatternConstraintsCompartment_7016SemanticChildren(view);
			case ExpressionActivityNodeExpressionFigureCompartment2EditPart.VISUAL_ID:
				return getExpressionActivityNodeExpressionFigureCompartment_7005SemanticChildren(view);
			case StoryNodeStoryNodeElementsCompartment2EditPart.VISUAL_ID:
				return getStoryNodeStoryNodeElementsCompartment_7010SemanticChildren(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmNodeDescriptor> getActivity_1000SemanticChildren(View view)
	{
		if (!view.isSetElement())
		{
			return Collections.emptyList();
		}
		Activity modelElement = (Activity) view.getElement();
		LinkedList<MlsdmNodeDescriptor> result = new LinkedList<MlsdmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getNodes().iterator(); it.hasNext();)
		{
			ActivityNode childElement = (ActivityNode) it.next();
			int visualID = MlsdmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == ActivityFinalNodeEditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == DecisionMergeNodeEditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == ExpressionActivityNodeEditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == FlowFinalNodeEditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == ForkJoinNodeEditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == InitialNodeEditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == StoryNodeEditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == StructuredNodeEditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmNodeDescriptor> getStructuredNode_2009SemanticChildren(View view)
	{
		if (!view.isSetElement())
		{
			return Collections.emptyList();
		}
		StructuredNode modelElement = (StructuredNode) view.getElement();
		LinkedList<MlsdmNodeDescriptor> result = new LinkedList<MlsdmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getNodes().iterator(); it.hasNext();)
		{
			ActivityNode childElement = (ActivityNode) it.next();
			int visualID = MlsdmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == DecisionMergeNode2EditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == ExpressionActivityNode2EditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == FlowFinalNode2EditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == ForkJoinNode2EditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == InitialNode2EditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == StoryNode2EditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == StructuredNode2EditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == ActivityFinalNode2EditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmNodeDescriptor> getStructuredNode_3018SemanticChildren(View view)
	{
		if (!view.isSetElement())
		{
			return Collections.emptyList();
		}
		StructuredNode modelElement = (StructuredNode) view.getElement();
		LinkedList<MlsdmNodeDescriptor> result = new LinkedList<MlsdmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getNodes().iterator(); it.hasNext();)
		{
			ActivityNode childElement = (ActivityNode) it.next();
			int visualID = MlsdmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == DecisionMergeNode2EditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == ExpressionActivityNode2EditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == FlowFinalNode2EditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == ForkJoinNode2EditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == InitialNode2EditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == StoryNode2EditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == StructuredNode2EditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == ActivityFinalNode2EditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmNodeDescriptor> getExpressionActivityNodeExpressionFigureCompartment_7001SemanticChildren(View view)
	{
		if (false == view.eContainer() instanceof View)
		{
			return Collections.emptyList();
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement())
		{
			return Collections.emptyList();
		}
		ExpressionActivityNode modelElement = (ExpressionActivityNode) containerView.getElement();
		LinkedList<MlsdmNodeDescriptor> result = new LinkedList<MlsdmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getExpressions().iterator(); it.hasNext();)
		{
			MLExpression childElement = (MLExpression) it.next();
			int visualID = MlsdmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == MLStringExpressionEditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == CallActionExpression2EditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmNodeDescriptor> getStoryNodeStoryNodeElementsCompartment_7009SemanticChildren(View view)
	{
		if (false == view.eContainer() instanceof View)
		{
			return Collections.emptyList();
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement())
		{
			return Collections.emptyList();
		}
		StoryNode modelElement = (StoryNode) containerView.getElement();
		LinkedList<MlsdmNodeDescriptor> result = new LinkedList<MlsdmNodeDescriptor>();
		{
			StoryPattern childElement = modelElement.getStoryPattern();
			int visualID = MlsdmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == StoryPatternEditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmNodeDescriptor> getStoryPatternStoryPatternElementsCompartment_7011SemanticChildren(View view)
	{
		if (false == view.eContainer() instanceof View)
		{
			return Collections.emptyList();
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement())
		{
			return Collections.emptyList();
		}
		StoryPattern modelElement = (StoryPattern) containerView.getElement();
		LinkedList<MlsdmNodeDescriptor> result = new LinkedList<MlsdmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getStoryPatternObjects().iterator(); it.hasNext();)
		{
			AbstractStoryPatternObject childElement = (AbstractStoryPatternObject) it.next();
			int visualID = MlsdmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == StoryPatternObjectEditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getNegativeApplicationConditions().iterator(); it.hasNext();)
		{
			StoryPattern childElement = (StoryPattern) it.next();
			int visualID = MlsdmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == StoryPattern2EditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmNodeDescriptor> getStoryPatternStoryPatternConstraintsCompartment_7012SemanticChildren(View view)
	{
		if (false == view.eContainer() instanceof View)
		{
			return Collections.emptyList();
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement())
		{
			return Collections.emptyList();
		}
		StoryPattern modelElement = (StoryPattern) containerView.getElement();
		LinkedList<MlsdmNodeDescriptor> result = new LinkedList<MlsdmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getConstraints().iterator(); it.hasNext();)
		{
			MLExpression childElement = (MLExpression) it.next();
			int visualID = MlsdmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == MLStringExpression3EditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == CallActionExpression3EditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmNodeDescriptor> getStoryPatternObjectStoryPatternObjectConstraintsCompartment_7003SemanticChildren(View view)
	{
		if (false == view.eContainer() instanceof View)
		{
			return Collections.emptyList();
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement())
		{
			return Collections.emptyList();
		}
		StoryPatternObject modelElement = (StoryPatternObject) containerView.getElement();
		LinkedList<MlsdmNodeDescriptor> result = new LinkedList<MlsdmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getConstraints().iterator(); it.hasNext();)
		{
			MLExpression childElement = (MLExpression) it.next();
			int visualID = MlsdmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == MLStringExpression2EditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == CallActionExpressionEditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmNodeDescriptor> getStoryPatternObjectStoryPatternObjectAttributeAssignmentsCompartment_7004SemanticChildren(
			View view)
	{
		if (false == view.eContainer() instanceof View)
		{
			return Collections.emptyList();
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement())
		{
			return Collections.emptyList();
		}
		StoryPatternObject modelElement = (StoryPatternObject) containerView.getElement();
		LinkedList<MlsdmNodeDescriptor> result = new LinkedList<MlsdmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getAttributeAssignments().iterator(); it.hasNext();)
		{
			AttributeAssignment childElement = (AttributeAssignment) it.next();
			int visualID = MlsdmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == AttributeAssignmentEditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmNodeDescriptor> getStoryPatternNegativeStoryPatternElementsCompartment_7015SemanticChildren(View view)
	{
		if (false == view.eContainer() instanceof View)
		{
			return Collections.emptyList();
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement())
		{
			return Collections.emptyList();
		}
		StoryPattern modelElement = (StoryPattern) containerView.getElement();
		LinkedList<MlsdmNodeDescriptor> result = new LinkedList<MlsdmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getStoryPatternObjects().iterator(); it.hasNext();)
		{
			AbstractStoryPatternObject childElement = (AbstractStoryPatternObject) it.next();
			int visualID = MlsdmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == StoryPatternObjectEditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator<?> it = modelElement.getNegativeApplicationConditions().iterator(); it.hasNext();)
		{
			StoryPattern childElement = (StoryPattern) it.next();
			int visualID = MlsdmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == StoryPattern2EditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmNodeDescriptor> getStoryPatternNegativeStoryPatternConstraintsCompartment_7016SemanticChildren(View view)
	{
		if (false == view.eContainer() instanceof View)
		{
			return Collections.emptyList();
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement())
		{
			return Collections.emptyList();
		}
		StoryPattern modelElement = (StoryPattern) containerView.getElement();
		LinkedList<MlsdmNodeDescriptor> result = new LinkedList<MlsdmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getConstraints().iterator(); it.hasNext();)
		{
			MLExpression childElement = (MLExpression) it.next();
			int visualID = MlsdmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == MLStringExpression3EditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == CallActionExpression3EditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmNodeDescriptor> getExpressionActivityNodeExpressionFigureCompartment_7005SemanticChildren(View view)
	{
		if (false == view.eContainer() instanceof View)
		{
			return Collections.emptyList();
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement())
		{
			return Collections.emptyList();
		}
		ExpressionActivityNode modelElement = (ExpressionActivityNode) containerView.getElement();
		LinkedList<MlsdmNodeDescriptor> result = new LinkedList<MlsdmNodeDescriptor>();
		for (Iterator<?> it = modelElement.getExpressions().iterator(); it.hasNext();)
		{
			MLExpression childElement = (MLExpression) it.next();
			int visualID = MlsdmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == MLStringExpressionEditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
			if (visualID == CallActionExpression2EditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmNodeDescriptor> getStoryNodeStoryNodeElementsCompartment_7010SemanticChildren(View view)
	{
		if (false == view.eContainer() instanceof View)
		{
			return Collections.emptyList();
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement())
		{
			return Collections.emptyList();
		}
		StoryNode modelElement = (StoryNode) containerView.getElement();
		LinkedList<MlsdmNodeDescriptor> result = new LinkedList<MlsdmNodeDescriptor>();
		{
			StoryPattern childElement = modelElement.getStoryPattern();
			int visualID = MlsdmVisualIDRegistry.getNodeVisualID(view, childElement);
			if (visualID == StoryPatternEditPart.VISUAL_ID)
			{
				result.add(new MlsdmNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getContainedLinks(View view)
	{
		switch (MlsdmVisualIDRegistry.getVisualID(view))
		{
			case ActivityEditPart.VISUAL_ID:
				return getActivity_1000ContainedLinks(view);
			case ActivityFinalNodeEditPart.VISUAL_ID:
				return getActivityFinalNode_2002ContainedLinks(view);
			case DecisionMergeNodeEditPart.VISUAL_ID:
				return getDecisionMergeNode_2006ContainedLinks(view);
			case ExpressionActivityNodeEditPart.VISUAL_ID:
				return getExpressionActivityNode_2001ContainedLinks(view);
			case FlowFinalNodeEditPart.VISUAL_ID:
				return getFlowFinalNode_2007ContainedLinks(view);
			case ForkJoinNodeEditPart.VISUAL_ID:
				return getForkJoinNode_2003ContainedLinks(view);
			case InitialNodeEditPart.VISUAL_ID:
				return getInitialNode_2004ContainedLinks(view);
			case StoryNodeEditPart.VISUAL_ID:
				return getStoryNode_2008ContainedLinks(view);
			case StructuredNodeEditPart.VISUAL_ID:
				return getStructuredNode_2009ContainedLinks(view);
			case MLStringExpressionEditPart.VISUAL_ID:
				return getMLStringExpression_3001ContainedLinks(view);
			case CallActionExpression2EditPart.VISUAL_ID:
				return getCallActionExpression_3013ContainedLinks(view);
			case StoryPatternEditPart.VISUAL_ID:
				return getStoryPattern_3002ContainedLinks(view);
			case StoryPatternObjectEditPart.VISUAL_ID:
				return getStoryPatternObject_3003ContainedLinks(view);
			case MLStringExpression2EditPart.VISUAL_ID:
				return getMLStringExpression_3004ContainedLinks(view);
			case AttributeAssignmentEditPart.VISUAL_ID:
				return getAttributeAssignment_3005ContainedLinks(view);
			case CallActionExpressionEditPart.VISUAL_ID:
				return getCallActionExpression_3012ContainedLinks(view);
			case MLStringExpression3EditPart.VISUAL_ID:
				return getMLStringExpression_3014ContainedLinks(view);
			case CallActionExpression3EditPart.VISUAL_ID:
				return getCallActionExpression_3015ContainedLinks(view);
			case StoryPattern2EditPart.VISUAL_ID:
				return getStoryPattern_3017ContainedLinks(view);
			case DecisionMergeNode2EditPart.VISUAL_ID:
				return getDecisionMergeNode_3006ContainedLinks(view);
			case ExpressionActivityNode2EditPart.VISUAL_ID:
				return getExpressionActivityNode_3007ContainedLinks(view);
			case FlowFinalNode2EditPart.VISUAL_ID:
				return getFlowFinalNode_3008ContainedLinks(view);
			case ForkJoinNode2EditPart.VISUAL_ID:
				return getForkJoinNode_3009ContainedLinks(view);
			case InitialNode2EditPart.VISUAL_ID:
				return getInitialNode_3010ContainedLinks(view);
			case StoryNode2EditPart.VISUAL_ID:
				return getStoryNode_3011ContainedLinks(view);
			case StructuredNode2EditPart.VISUAL_ID:
				return getStructuredNode_3018ContainedLinks(view);
			case ActivityFinalNode2EditPart.VISUAL_ID:
				return getActivityFinalNode_3019ContainedLinks(view);
			case ActivityEdgeEditPart.VISUAL_ID:
				return getActivityEdge_4001ContainedLinks(view);
			case StoryPatternLinkEditPart.VISUAL_ID:
				return getStoryPatternLink_4002ContainedLinks(view);
			case ContainmentLinkEditPart.VISUAL_ID:
				return getContainmentLink_4003ContainedLinks(view);
			case ExpressionLinkEditPart.VISUAL_ID:
				return getExpressionLink_4004ContainedLinks(view);
			case LinkOrderConstraintEditPart.VISUAL_ID:
				return getLinkOrderConstraint_4005ContainedLinks(view);
			case MapEntryLinkEditPart.VISUAL_ID:
				return getMapEntryLink_4006ContainedLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getIncomingLinks(View view)
	{
		switch (MlsdmVisualIDRegistry.getVisualID(view))
		{
			case ActivityFinalNodeEditPart.VISUAL_ID:
				return getActivityFinalNode_2002IncomingLinks(view);
			case DecisionMergeNodeEditPart.VISUAL_ID:
				return getDecisionMergeNode_2006IncomingLinks(view);
			case ExpressionActivityNodeEditPart.VISUAL_ID:
				return getExpressionActivityNode_2001IncomingLinks(view);
			case FlowFinalNodeEditPart.VISUAL_ID:
				return getFlowFinalNode_2007IncomingLinks(view);
			case ForkJoinNodeEditPart.VISUAL_ID:
				return getForkJoinNode_2003IncomingLinks(view);
			case InitialNodeEditPart.VISUAL_ID:
				return getInitialNode_2004IncomingLinks(view);
			case StoryNodeEditPart.VISUAL_ID:
				return getStoryNode_2008IncomingLinks(view);
			case StructuredNodeEditPart.VISUAL_ID:
				return getStructuredNode_2009IncomingLinks(view);
			case MLStringExpressionEditPart.VISUAL_ID:
				return getMLStringExpression_3001IncomingLinks(view);
			case CallActionExpression2EditPart.VISUAL_ID:
				return getCallActionExpression_3013IncomingLinks(view);
			case StoryPatternEditPart.VISUAL_ID:
				return getStoryPattern_3002IncomingLinks(view);
			case StoryPatternObjectEditPart.VISUAL_ID:
				return getStoryPatternObject_3003IncomingLinks(view);
			case MLStringExpression2EditPart.VISUAL_ID:
				return getMLStringExpression_3004IncomingLinks(view);
			case AttributeAssignmentEditPart.VISUAL_ID:
				return getAttributeAssignment_3005IncomingLinks(view);
			case CallActionExpressionEditPart.VISUAL_ID:
				return getCallActionExpression_3012IncomingLinks(view);
			case MLStringExpression3EditPart.VISUAL_ID:
				return getMLStringExpression_3014IncomingLinks(view);
			case CallActionExpression3EditPart.VISUAL_ID:
				return getCallActionExpression_3015IncomingLinks(view);
			case StoryPattern2EditPart.VISUAL_ID:
				return getStoryPattern_3017IncomingLinks(view);
			case DecisionMergeNode2EditPart.VISUAL_ID:
				return getDecisionMergeNode_3006IncomingLinks(view);
			case ExpressionActivityNode2EditPart.VISUAL_ID:
				return getExpressionActivityNode_3007IncomingLinks(view);
			case FlowFinalNode2EditPart.VISUAL_ID:
				return getFlowFinalNode_3008IncomingLinks(view);
			case ForkJoinNode2EditPart.VISUAL_ID:
				return getForkJoinNode_3009IncomingLinks(view);
			case InitialNode2EditPart.VISUAL_ID:
				return getInitialNode_3010IncomingLinks(view);
			case StoryNode2EditPart.VISUAL_ID:
				return getStoryNode_3011IncomingLinks(view);
			case StructuredNode2EditPart.VISUAL_ID:
				return getStructuredNode_3018IncomingLinks(view);
			case ActivityFinalNode2EditPart.VISUAL_ID:
				return getActivityFinalNode_3019IncomingLinks(view);
			case ActivityEdgeEditPart.VISUAL_ID:
				return getActivityEdge_4001IncomingLinks(view);
			case StoryPatternLinkEditPart.VISUAL_ID:
				return getStoryPatternLink_4002IncomingLinks(view);
			case ContainmentLinkEditPart.VISUAL_ID:
				return getContainmentLink_4003IncomingLinks(view);
			case ExpressionLinkEditPart.VISUAL_ID:
				return getExpressionLink_4004IncomingLinks(view);
			case LinkOrderConstraintEditPart.VISUAL_ID:
				return getLinkOrderConstraint_4005IncomingLinks(view);
			case MapEntryLinkEditPart.VISUAL_ID:
				return getMapEntryLink_4006IncomingLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getOutgoingLinks(View view)
	{
		switch (MlsdmVisualIDRegistry.getVisualID(view))
		{
			case ActivityFinalNodeEditPart.VISUAL_ID:
				return getActivityFinalNode_2002OutgoingLinks(view);
			case DecisionMergeNodeEditPart.VISUAL_ID:
				return getDecisionMergeNode_2006OutgoingLinks(view);
			case ExpressionActivityNodeEditPart.VISUAL_ID:
				return getExpressionActivityNode_2001OutgoingLinks(view);
			case FlowFinalNodeEditPart.VISUAL_ID:
				return getFlowFinalNode_2007OutgoingLinks(view);
			case ForkJoinNodeEditPart.VISUAL_ID:
				return getForkJoinNode_2003OutgoingLinks(view);
			case InitialNodeEditPart.VISUAL_ID:
				return getInitialNode_2004OutgoingLinks(view);
			case StoryNodeEditPart.VISUAL_ID:
				return getStoryNode_2008OutgoingLinks(view);
			case StructuredNodeEditPart.VISUAL_ID:
				return getStructuredNode_2009OutgoingLinks(view);
			case MLStringExpressionEditPart.VISUAL_ID:
				return getMLStringExpression_3001OutgoingLinks(view);
			case CallActionExpression2EditPart.VISUAL_ID:
				return getCallActionExpression_3013OutgoingLinks(view);
			case StoryPatternEditPart.VISUAL_ID:
				return getStoryPattern_3002OutgoingLinks(view);
			case StoryPatternObjectEditPart.VISUAL_ID:
				return getStoryPatternObject_3003OutgoingLinks(view);
			case MLStringExpression2EditPart.VISUAL_ID:
				return getMLStringExpression_3004OutgoingLinks(view);
			case AttributeAssignmentEditPart.VISUAL_ID:
				return getAttributeAssignment_3005OutgoingLinks(view);
			case CallActionExpressionEditPart.VISUAL_ID:
				return getCallActionExpression_3012OutgoingLinks(view);
			case MLStringExpression3EditPart.VISUAL_ID:
				return getMLStringExpression_3014OutgoingLinks(view);
			case CallActionExpression3EditPart.VISUAL_ID:
				return getCallActionExpression_3015OutgoingLinks(view);
			case StoryPattern2EditPart.VISUAL_ID:
				return getStoryPattern_3017OutgoingLinks(view);
			case DecisionMergeNode2EditPart.VISUAL_ID:
				return getDecisionMergeNode_3006OutgoingLinks(view);
			case ExpressionActivityNode2EditPart.VISUAL_ID:
				return getExpressionActivityNode_3007OutgoingLinks(view);
			case FlowFinalNode2EditPart.VISUAL_ID:
				return getFlowFinalNode_3008OutgoingLinks(view);
			case ForkJoinNode2EditPart.VISUAL_ID:
				return getForkJoinNode_3009OutgoingLinks(view);
			case InitialNode2EditPart.VISUAL_ID:
				return getInitialNode_3010OutgoingLinks(view);
			case StoryNode2EditPart.VISUAL_ID:
				return getStoryNode_3011OutgoingLinks(view);
			case StructuredNode2EditPart.VISUAL_ID:
				return getStructuredNode_3018OutgoingLinks(view);
			case ActivityFinalNode2EditPart.VISUAL_ID:
				return getActivityFinalNode_3019OutgoingLinks(view);
			case ActivityEdgeEditPart.VISUAL_ID:
				return getActivityEdge_4001OutgoingLinks(view);
			case StoryPatternLinkEditPart.VISUAL_ID:
				return getStoryPatternLink_4002OutgoingLinks(view);
			case ContainmentLinkEditPart.VISUAL_ID:
				return getContainmentLink_4003OutgoingLinks(view);
			case ExpressionLinkEditPart.VISUAL_ID:
				return getExpressionLink_4004OutgoingLinks(view);
			case LinkOrderConstraintEditPart.VISUAL_ID:
				return getLinkOrderConstraint_4005OutgoingLinks(view);
			case MapEntryLinkEditPart.VISUAL_ID:
				return getMapEntryLink_4006OutgoingLinks(view);
		}
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getActivity_1000ContainedLinks(View view)
	{
		Activity modelElement = (Activity) view.getElement();
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getContainedTypeModelFacetLinks_ActivityEdge_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getActivityFinalNode_2002ContainedLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getDecisionMergeNode_2006ContainedLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getExpressionActivityNode_2001ContainedLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getFlowFinalNode_2007ContainedLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getForkJoinNode_2003ContainedLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getInitialNode_2004ContainedLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getStoryNode_2008ContainedLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getStructuredNode_2009ContainedLinks(View view)
	{
		StructuredNode modelElement = (StructuredNode) view.getElement();
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getContainedTypeModelFacetLinks_ActivityEdge_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getMLStringExpression_3001ContainedLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getCallActionExpression_3013ContainedLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getStoryPattern_3002ContainedLinks(View view)
	{
		StoryPattern modelElement = (StoryPattern) view.getElement();
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getContainedTypeModelFacetLinks_StoryPatternLink_4002(modelElement));
		result.addAll(getContainedTypeModelFacetLinks_ContainmentLink_4003(modelElement));
		result.addAll(getContainedTypeModelFacetLinks_ExpressionLink_4004(modelElement));
		result.addAll(getContainedTypeModelFacetLinks_LinkOrderConstraint_4005(modelElement));
		result.addAll(getContainedTypeModelFacetLinks_MapEntryLink_4006(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getStoryPatternObject_3003ContainedLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getMLStringExpression_3004ContainedLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getAttributeAssignment_3005ContainedLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getCallActionExpression_3012ContainedLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getMLStringExpression_3014ContainedLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getCallActionExpression_3015ContainedLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getStoryPattern_3017ContainedLinks(View view)
	{
		StoryPattern modelElement = (StoryPattern) view.getElement();
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getContainedTypeModelFacetLinks_StoryPatternLink_4002(modelElement));
		result.addAll(getContainedTypeModelFacetLinks_ContainmentLink_4003(modelElement));
		result.addAll(getContainedTypeModelFacetLinks_ExpressionLink_4004(modelElement));
		result.addAll(getContainedTypeModelFacetLinks_LinkOrderConstraint_4005(modelElement));
		result.addAll(getContainedTypeModelFacetLinks_MapEntryLink_4006(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getDecisionMergeNode_3006ContainedLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getExpressionActivityNode_3007ContainedLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getFlowFinalNode_3008ContainedLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getForkJoinNode_3009ContainedLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getInitialNode_3010ContainedLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getStoryNode_3011ContainedLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getStructuredNode_3018ContainedLinks(View view)
	{
		StructuredNode modelElement = (StructuredNode) view.getElement();
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getContainedTypeModelFacetLinks_ActivityEdge_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getActivityFinalNode_3019ContainedLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getActivityEdge_4001ContainedLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getStoryPatternLink_4002ContainedLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getContainmentLink_4003ContainedLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getExpressionLink_4004ContainedLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getLinkOrderConstraint_4005ContainedLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getMapEntryLink_4006ContainedLinks(View view)
	{
		MapEntryLink modelElement = (MapEntryLink) view.getElement();
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_MapEntryLink_ValueTarget_4007(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getActivityFinalNode_2002IncomingLinks(View view)
	{
		ActivityFinalNode modelElement = (ActivityFinalNode) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_ActivityEdge_4001(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getDecisionMergeNode_2006IncomingLinks(View view)
	{
		DecisionMergeNode modelElement = (DecisionMergeNode) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_ActivityEdge_4001(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getExpressionActivityNode_2001IncomingLinks(View view)
	{
		ExpressionActivityNode modelElement = (ExpressionActivityNode) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_ActivityEdge_4001(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getFlowFinalNode_2007IncomingLinks(View view)
	{
		FlowFinalNode modelElement = (FlowFinalNode) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_ActivityEdge_4001(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getForkJoinNode_2003IncomingLinks(View view)
	{
		ForkJoinNode modelElement = (ForkJoinNode) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_ActivityEdge_4001(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getInitialNode_2004IncomingLinks(View view)
	{
		InitialNode modelElement = (InitialNode) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_ActivityEdge_4001(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getStoryNode_2008IncomingLinks(View view)
	{
		StoryNode modelElement = (StoryNode) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_ActivityEdge_4001(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getStructuredNode_2009IncomingLinks(View view)
	{
		StructuredNode modelElement = (StructuredNode) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_ActivityEdge_4001(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getMLStringExpression_3001IncomingLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getCallActionExpression_3013IncomingLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getStoryPattern_3002IncomingLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getStoryPatternObject_3003IncomingLinks(View view)
	{
		StoryPatternObject modelElement = (StoryPatternObject) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_StoryPatternLink_4002(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_ContainmentLink_4003(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_ExpressionLink_4004(modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_MapEntryLink_4006(modelElement, crossReferences));
		result.addAll(getIncomingFeatureModelFacetLinks_MapEntryLink_ValueTarget_4007(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getMLStringExpression_3004IncomingLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getAttributeAssignment_3005IncomingLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getCallActionExpression_3012IncomingLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getMLStringExpression_3014IncomingLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getCallActionExpression_3015IncomingLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getStoryPattern_3017IncomingLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getDecisionMergeNode_3006IncomingLinks(View view)
	{
		DecisionMergeNode modelElement = (DecisionMergeNode) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_ActivityEdge_4001(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getExpressionActivityNode_3007IncomingLinks(View view)
	{
		ExpressionActivityNode modelElement = (ExpressionActivityNode) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_ActivityEdge_4001(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getFlowFinalNode_3008IncomingLinks(View view)
	{
		FlowFinalNode modelElement = (FlowFinalNode) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_ActivityEdge_4001(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getForkJoinNode_3009IncomingLinks(View view)
	{
		ForkJoinNode modelElement = (ForkJoinNode) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_ActivityEdge_4001(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getInitialNode_3010IncomingLinks(View view)
	{
		InitialNode modelElement = (InitialNode) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_ActivityEdge_4001(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getStoryNode_3011IncomingLinks(View view)
	{
		StoryNode modelElement = (StoryNode) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_ActivityEdge_4001(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getStructuredNode_3018IncomingLinks(View view)
	{
		StructuredNode modelElement = (StructuredNode) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_ActivityEdge_4001(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getActivityFinalNode_3019IncomingLinks(View view)
	{
		ActivityFinalNode modelElement = (ActivityFinalNode) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_ActivityEdge_4001(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getActivityEdge_4001IncomingLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getStoryPatternLink_4002IncomingLinks(View view)
	{
		StoryPatternLink modelElement = (StoryPatternLink) view.getElement();
		Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getIncomingTypeModelFacetLinks_LinkOrderConstraint_4005(modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getContainmentLink_4003IncomingLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getExpressionLink_4004IncomingLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getLinkOrderConstraint_4005IncomingLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getMapEntryLink_4006IncomingLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getActivityFinalNode_2002OutgoingLinks(View view)
	{
		ActivityFinalNode modelElement = (ActivityFinalNode) view.getElement();
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_ActivityEdge_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getDecisionMergeNode_2006OutgoingLinks(View view)
	{
		DecisionMergeNode modelElement = (DecisionMergeNode) view.getElement();
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_ActivityEdge_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getExpressionActivityNode_2001OutgoingLinks(View view)
	{
		ExpressionActivityNode modelElement = (ExpressionActivityNode) view.getElement();
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_ActivityEdge_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getFlowFinalNode_2007OutgoingLinks(View view)
	{
		FlowFinalNode modelElement = (FlowFinalNode) view.getElement();
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_ActivityEdge_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getForkJoinNode_2003OutgoingLinks(View view)
	{
		ForkJoinNode modelElement = (ForkJoinNode) view.getElement();
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_ActivityEdge_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getInitialNode_2004OutgoingLinks(View view)
	{
		InitialNode modelElement = (InitialNode) view.getElement();
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_ActivityEdge_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getStoryNode_2008OutgoingLinks(View view)
	{
		StoryNode modelElement = (StoryNode) view.getElement();
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_ActivityEdge_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getStructuredNode_2009OutgoingLinks(View view)
	{
		StructuredNode modelElement = (StructuredNode) view.getElement();
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_ActivityEdge_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getMLStringExpression_3001OutgoingLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getCallActionExpression_3013OutgoingLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getStoryPattern_3002OutgoingLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getStoryPatternObject_3003OutgoingLinks(View view)
	{
		StoryPatternObject modelElement = (StoryPatternObject) view.getElement();
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_StoryPatternLink_4002(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_ContainmentLink_4003(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_ExpressionLink_4004(modelElement));
		result.addAll(getOutgoingTypeModelFacetLinks_MapEntryLink_4006(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getMLStringExpression_3004OutgoingLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getAttributeAssignment_3005OutgoingLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getCallActionExpression_3012OutgoingLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getMLStringExpression_3014OutgoingLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getCallActionExpression_3015OutgoingLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getStoryPattern_3017OutgoingLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getDecisionMergeNode_3006OutgoingLinks(View view)
	{
		DecisionMergeNode modelElement = (DecisionMergeNode) view.getElement();
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_ActivityEdge_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getExpressionActivityNode_3007OutgoingLinks(View view)
	{
		ExpressionActivityNode modelElement = (ExpressionActivityNode) view.getElement();
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_ActivityEdge_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getFlowFinalNode_3008OutgoingLinks(View view)
	{
		FlowFinalNode modelElement = (FlowFinalNode) view.getElement();
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_ActivityEdge_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getForkJoinNode_3009OutgoingLinks(View view)
	{
		ForkJoinNode modelElement = (ForkJoinNode) view.getElement();
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_ActivityEdge_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getInitialNode_3010OutgoingLinks(View view)
	{
		InitialNode modelElement = (InitialNode) view.getElement();
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_ActivityEdge_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getStoryNode_3011OutgoingLinks(View view)
	{
		StoryNode modelElement = (StoryNode) view.getElement();
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_ActivityEdge_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getStructuredNode_3018OutgoingLinks(View view)
	{
		StructuredNode modelElement = (StructuredNode) view.getElement();
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_ActivityEdge_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getActivityFinalNode_3019OutgoingLinks(View view)
	{
		ActivityFinalNode modelElement = (ActivityFinalNode) view.getElement();
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_ActivityEdge_4001(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getActivityEdge_4001OutgoingLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getStoryPatternLink_4002OutgoingLinks(View view)
	{
		StoryPatternLink modelElement = (StoryPatternLink) view.getElement();
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getOutgoingTypeModelFacetLinks_LinkOrderConstraint_4005(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getContainmentLink_4003OutgoingLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getExpressionLink_4004OutgoingLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getLinkOrderConstraint_4005OutgoingLinks(View view)
	{
		return Collections.emptyList();
	}

	/**
	 * @generated
	 */
	public static List<MlsdmLinkDescriptor> getMapEntryLink_4006OutgoingLinks(View view)
	{
		MapEntryLink modelElement = (MapEntryLink) view.getElement();
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		result.addAll(getOutgoingFeatureModelFacetLinks_MapEntryLink_ValueTarget_4007(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlsdmLinkDescriptor> getContainedTypeModelFacetLinks_ActivityEdge_4001(ActivityNodeContainer container)
	{
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		for (Iterator<?> links = container.getEdges().iterator(); links.hasNext();)
		{
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof ActivityEdge)
			{
				continue;
			}
			ActivityEdge link = (ActivityEdge) linkObject;
			if (ActivityEdgeEditPart.VISUAL_ID != MlsdmVisualIDRegistry.getLinkWithClassVisualID(link))
			{
				continue;
			}
			ActivityNode dst = link.getTarget();
			ActivityNode src = link.getSource();
			result.add(new MlsdmLinkDescriptor(src, dst, link, MlsdmElementTypes.ActivityEdge_4001, ActivityEdgeEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlsdmLinkDescriptor> getContainedTypeModelFacetLinks_StoryPatternLink_4002(StoryPattern container)
	{
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		for (Iterator<?> links = container.getStoryPatternLinks().iterator(); links.hasNext();)
		{
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof StoryPatternLink)
			{
				continue;
			}
			StoryPatternLink link = (StoryPatternLink) linkObject;
			if (StoryPatternLinkEditPart.VISUAL_ID != MlsdmVisualIDRegistry.getLinkWithClassVisualID(link))
			{
				continue;
			}
			AbstractStoryPatternObject dst = link.getTarget();
			AbstractStoryPatternObject src = link.getSource();
			result.add(new MlsdmLinkDescriptor(src, dst, link, MlsdmElementTypes.StoryPatternLink_4002, StoryPatternLinkEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlsdmLinkDescriptor> getContainedTypeModelFacetLinks_ContainmentLink_4003(StoryPattern container)
	{
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		for (Iterator<?> links = container.getStoryPatternLinks().iterator(); links.hasNext();)
		{
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof ContainmentLink)
			{
				continue;
			}
			ContainmentLink link = (ContainmentLink) linkObject;
			if (ContainmentLinkEditPart.VISUAL_ID != MlsdmVisualIDRegistry.getLinkWithClassVisualID(link))
			{
				continue;
			}
			AbstractStoryPatternObject dst = link.getTarget();
			AbstractStoryPatternObject src = link.getSource();
			result.add(new MlsdmLinkDescriptor(src, dst, link, MlsdmElementTypes.ContainmentLink_4003, ContainmentLinkEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlsdmLinkDescriptor> getContainedTypeModelFacetLinks_ExpressionLink_4004(StoryPattern container)
	{
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		for (Iterator<?> links = container.getStoryPatternLinks().iterator(); links.hasNext();)
		{
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof ExpressionLink)
			{
				continue;
			}
			ExpressionLink link = (ExpressionLink) linkObject;
			if (ExpressionLinkEditPart.VISUAL_ID != MlsdmVisualIDRegistry.getLinkWithClassVisualID(link))
			{
				continue;
			}
			AbstractStoryPatternObject dst = link.getTarget();
			AbstractStoryPatternObject src = link.getSource();
			result.add(new MlsdmLinkDescriptor(src, dst, link, MlsdmElementTypes.ExpressionLink_4004, ExpressionLinkEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlsdmLinkDescriptor> getContainedTypeModelFacetLinks_LinkOrderConstraint_4005(StoryPattern container)
	{
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		for (Iterator<?> links = container.getLinkOrderConstraints().iterator(); links.hasNext();)
		{
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof LinkOrderConstraint)
			{
				continue;
			}
			LinkOrderConstraint link = (LinkOrderConstraint) linkObject;
			if (LinkOrderConstraintEditPart.VISUAL_ID != MlsdmVisualIDRegistry.getLinkWithClassVisualID(link))
			{
				continue;
			}
			StoryPatternLink dst = link.getSuccessorLink();
			StoryPatternLink src = link.getPredecessorLink();
			result.add(new MlsdmLinkDescriptor(src, dst, link, MlsdmElementTypes.LinkOrderConstraint_4005,
					LinkOrderConstraintEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlsdmLinkDescriptor> getContainedTypeModelFacetLinks_MapEntryLink_4006(StoryPattern container)
	{
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		for (Iterator<?> links = container.getStoryPatternLinks().iterator(); links.hasNext();)
		{
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof MapEntryLink)
			{
				continue;
			}
			MapEntryLink link = (MapEntryLink) linkObject;
			if (MapEntryLinkEditPart.VISUAL_ID != MlsdmVisualIDRegistry.getLinkWithClassVisualID(link))
			{
				continue;
			}
			AbstractStoryPatternObject dst = link.getTarget();
			AbstractStoryPatternObject src = link.getSource();
			result.add(new MlsdmLinkDescriptor(src, dst, link, MlsdmElementTypes.MapEntryLink_4006, MapEntryLinkEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlsdmLinkDescriptor> getIncomingTypeModelFacetLinks_ActivityEdge_4001(ActivityNode target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences)
	{
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences.get(target);
		for (EStructuralFeature.Setting setting : settings)
		{
			if (setting.getEStructuralFeature() != MlsdmPackage.eINSTANCE.getActivityEdge_Target()
					|| false == setting.getEObject() instanceof ActivityEdge)
			{
				continue;
			}
			ActivityEdge link = (ActivityEdge) setting.getEObject();
			if (ActivityEdgeEditPart.VISUAL_ID != MlsdmVisualIDRegistry.getLinkWithClassVisualID(link))
			{
				continue;
			}
			ActivityNode src = link.getSource();
			result.add(new MlsdmLinkDescriptor(src, target, link, MlsdmElementTypes.ActivityEdge_4001, ActivityEdgeEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlsdmLinkDescriptor> getIncomingTypeModelFacetLinks_StoryPatternLink_4002(AbstractStoryPatternObject target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences)
	{
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences.get(target);
		for (EStructuralFeature.Setting setting : settings)
		{
			if (setting.getEStructuralFeature() != MlstorypatternsPackage.eINSTANCE.getAbstractStoryPatternLink_Target()
					|| false == setting.getEObject() instanceof StoryPatternLink)
			{
				continue;
			}
			StoryPatternLink link = (StoryPatternLink) setting.getEObject();
			if (StoryPatternLinkEditPart.VISUAL_ID != MlsdmVisualIDRegistry.getLinkWithClassVisualID(link))
			{
				continue;
			}
			AbstractStoryPatternObject src = link.getSource();
			result.add(new MlsdmLinkDescriptor(src, target, link, MlsdmElementTypes.StoryPatternLink_4002,
					StoryPatternLinkEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlsdmLinkDescriptor> getIncomingTypeModelFacetLinks_ContainmentLink_4003(AbstractStoryPatternObject target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences)
	{
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences.get(target);
		for (EStructuralFeature.Setting setting : settings)
		{
			if (setting.getEStructuralFeature() != MlstorypatternsPackage.eINSTANCE.getAbstractStoryPatternLink_Target()
					|| false == setting.getEObject() instanceof ContainmentLink)
			{
				continue;
			}
			ContainmentLink link = (ContainmentLink) setting.getEObject();
			if (ContainmentLinkEditPart.VISUAL_ID != MlsdmVisualIDRegistry.getLinkWithClassVisualID(link))
			{
				continue;
			}
			AbstractStoryPatternObject src = link.getSource();
			result.add(new MlsdmLinkDescriptor(src, target, link, MlsdmElementTypes.ContainmentLink_4003, ContainmentLinkEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlsdmLinkDescriptor> getIncomingTypeModelFacetLinks_ExpressionLink_4004(AbstractStoryPatternObject target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences)
	{
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences.get(target);
		for (EStructuralFeature.Setting setting : settings)
		{
			if (setting.getEStructuralFeature() != MlstorypatternsPackage.eINSTANCE.getAbstractStoryPatternLink_Target()
					|| false == setting.getEObject() instanceof ExpressionLink)
			{
				continue;
			}
			ExpressionLink link = (ExpressionLink) setting.getEObject();
			if (ExpressionLinkEditPart.VISUAL_ID != MlsdmVisualIDRegistry.getLinkWithClassVisualID(link))
			{
				continue;
			}
			AbstractStoryPatternObject src = link.getSource();
			result.add(new MlsdmLinkDescriptor(src, target, link, MlsdmElementTypes.ExpressionLink_4004, ExpressionLinkEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlsdmLinkDescriptor> getIncomingTypeModelFacetLinks_LinkOrderConstraint_4005(StoryPatternLink target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences)
	{
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences.get(target);
		for (EStructuralFeature.Setting setting : settings)
		{
			if (setting.getEStructuralFeature() != MlstorypatternsPackage.eINSTANCE.getLinkOrderConstraint_SuccessorLink()
					|| false == setting.getEObject() instanceof LinkOrderConstraint)
			{
				continue;
			}
			LinkOrderConstraint link = (LinkOrderConstraint) setting.getEObject();
			if (LinkOrderConstraintEditPart.VISUAL_ID != MlsdmVisualIDRegistry.getLinkWithClassVisualID(link))
			{
				continue;
			}
			StoryPatternLink src = link.getPredecessorLink();
			result.add(new MlsdmLinkDescriptor(src, target, link, MlsdmElementTypes.LinkOrderConstraint_4005,
					LinkOrderConstraintEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlsdmLinkDescriptor> getIncomingTypeModelFacetLinks_MapEntryLink_4006(AbstractStoryPatternObject target,
			Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences)
	{
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences.get(target);
		for (EStructuralFeature.Setting setting : settings)
		{
			if (setting.getEStructuralFeature() != MlstorypatternsPackage.eINSTANCE.getAbstractStoryPatternLink_Target()
					|| false == setting.getEObject() instanceof MapEntryLink)
			{
				continue;
			}
			MapEntryLink link = (MapEntryLink) setting.getEObject();
			if (MapEntryLinkEditPart.VISUAL_ID != MlsdmVisualIDRegistry.getLinkWithClassVisualID(link))
			{
				continue;
			}
			AbstractStoryPatternObject src = link.getSource();
			result.add(new MlsdmLinkDescriptor(src, target, link, MlsdmElementTypes.MapEntryLink_4006, MapEntryLinkEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlsdmLinkDescriptor> getIncomingFeatureModelFacetLinks_MapEntryLink_ValueTarget_4007(
			AbstractStoryPatternObject target, Map<EObject, Collection<EStructuralFeature.Setting>> crossReferences)
	{
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		Collection<EStructuralFeature.Setting> settings = crossReferences.get(target);
		for (EStructuralFeature.Setting setting : settings)
		{
			if (setting.getEStructuralFeature() == MlstorypatternsPackage.eINSTANCE.getMapEntryLink_ValueTarget())
			{
				result.add(new MlsdmLinkDescriptor(setting.getEObject(), target, MlsdmElementTypes.MapEntryLinkValueTarget_4007,
						MapEntryLinkValueTargetEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlsdmLinkDescriptor> getOutgoingTypeModelFacetLinks_ActivityEdge_4001(ActivityNode source)
	{
		ActivityNodeContainer container = null;
		// Find container element for the link.
		// Climb up by containment hierarchy starting from the source
		// and return the first element that is instance of the container class.
		for (EObject element = source; element != null && container == null; element = element.eContainer())
		{
			if (element instanceof ActivityNodeContainer)
			{
				container = (ActivityNodeContainer) element;
			}
		}
		if (container == null)
		{
			return Collections.emptyList();
		}
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		for (Iterator<?> links = container.getEdges().iterator(); links.hasNext();)
		{
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof ActivityEdge)
			{
				continue;
			}
			ActivityEdge link = (ActivityEdge) linkObject;
			if (ActivityEdgeEditPart.VISUAL_ID != MlsdmVisualIDRegistry.getLinkWithClassVisualID(link))
			{
				continue;
			}
			ActivityNode dst = link.getTarget();
			ActivityNode src = link.getSource();
			if (src != source)
			{
				continue;
			}
			result.add(new MlsdmLinkDescriptor(src, dst, link, MlsdmElementTypes.ActivityEdge_4001, ActivityEdgeEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlsdmLinkDescriptor> getOutgoingTypeModelFacetLinks_StoryPatternLink_4002(AbstractStoryPatternObject source)
	{
		StoryPattern container = null;
		// Find container element for the link.
		// Climb up by containment hierarchy starting from the source
		// and return the first element that is instance of the container class.
		for (EObject element = source; element != null && container == null; element = element.eContainer())
		{
			if (element instanceof StoryPattern)
			{
				container = (StoryPattern) element;
			}
		}
		if (container == null)
		{
			return Collections.emptyList();
		}
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		for (Iterator<?> links = container.getStoryPatternLinks().iterator(); links.hasNext();)
		{
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof StoryPatternLink)
			{
				continue;
			}
			StoryPatternLink link = (StoryPatternLink) linkObject;
			if (StoryPatternLinkEditPart.VISUAL_ID != MlsdmVisualIDRegistry.getLinkWithClassVisualID(link))
			{
				continue;
			}
			AbstractStoryPatternObject dst = link.getTarget();
			AbstractStoryPatternObject src = link.getSource();
			if (src != source)
			{
				continue;
			}
			result.add(new MlsdmLinkDescriptor(src, dst, link, MlsdmElementTypes.StoryPatternLink_4002, StoryPatternLinkEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlsdmLinkDescriptor> getOutgoingTypeModelFacetLinks_ContainmentLink_4003(AbstractStoryPatternObject source)
	{
		StoryPattern container = null;
		// Find container element for the link.
		// Climb up by containment hierarchy starting from the source
		// and return the first element that is instance of the container class.
		for (EObject element = source; element != null && container == null; element = element.eContainer())
		{
			if (element instanceof StoryPattern)
			{
				container = (StoryPattern) element;
			}
		}
		if (container == null)
		{
			return Collections.emptyList();
		}
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		for (Iterator<?> links = container.getStoryPatternLinks().iterator(); links.hasNext();)
		{
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof ContainmentLink)
			{
				continue;
			}
			ContainmentLink link = (ContainmentLink) linkObject;
			if (ContainmentLinkEditPart.VISUAL_ID != MlsdmVisualIDRegistry.getLinkWithClassVisualID(link))
			{
				continue;
			}
			AbstractStoryPatternObject dst = link.getTarget();
			AbstractStoryPatternObject src = link.getSource();
			if (src != source)
			{
				continue;
			}
			result.add(new MlsdmLinkDescriptor(src, dst, link, MlsdmElementTypes.ContainmentLink_4003, ContainmentLinkEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlsdmLinkDescriptor> getOutgoingTypeModelFacetLinks_ExpressionLink_4004(AbstractStoryPatternObject source)
	{
		StoryPattern container = null;
		// Find container element for the link.
		// Climb up by containment hierarchy starting from the source
		// and return the first element that is instance of the container class.
		for (EObject element = source; element != null && container == null; element = element.eContainer())
		{
			if (element instanceof StoryPattern)
			{
				container = (StoryPattern) element;
			}
		}
		if (container == null)
		{
			return Collections.emptyList();
		}
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		for (Iterator<?> links = container.getStoryPatternLinks().iterator(); links.hasNext();)
		{
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof ExpressionLink)
			{
				continue;
			}
			ExpressionLink link = (ExpressionLink) linkObject;
			if (ExpressionLinkEditPart.VISUAL_ID != MlsdmVisualIDRegistry.getLinkWithClassVisualID(link))
			{
				continue;
			}
			AbstractStoryPatternObject dst = link.getTarget();
			AbstractStoryPatternObject src = link.getSource();
			if (src != source)
			{
				continue;
			}
			result.add(new MlsdmLinkDescriptor(src, dst, link, MlsdmElementTypes.ExpressionLink_4004, ExpressionLinkEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlsdmLinkDescriptor> getOutgoingTypeModelFacetLinks_LinkOrderConstraint_4005(StoryPatternLink source)
	{
		StoryPattern container = null;
		// Find container element for the link.
		// Climb up by containment hierarchy starting from the source
		// and return the first element that is instance of the container class.
		for (EObject element = source; element != null && container == null; element = element.eContainer())
		{
			if (element instanceof StoryPattern)
			{
				container = (StoryPattern) element;
			}
		}
		if (container == null)
		{
			return Collections.emptyList();
		}
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		for (Iterator<?> links = container.getLinkOrderConstraints().iterator(); links.hasNext();)
		{
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof LinkOrderConstraint)
			{
				continue;
			}
			LinkOrderConstraint link = (LinkOrderConstraint) linkObject;
			if (LinkOrderConstraintEditPart.VISUAL_ID != MlsdmVisualIDRegistry.getLinkWithClassVisualID(link))
			{
				continue;
			}
			StoryPatternLink dst = link.getSuccessorLink();
			StoryPatternLink src = link.getPredecessorLink();
			if (src != source)
			{
				continue;
			}
			result.add(new MlsdmLinkDescriptor(src, dst, link, MlsdmElementTypes.LinkOrderConstraint_4005,
					LinkOrderConstraintEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlsdmLinkDescriptor> getOutgoingTypeModelFacetLinks_MapEntryLink_4006(AbstractStoryPatternObject source)
	{
		StoryPattern container = null;
		// Find container element for the link.
		// Climb up by containment hierarchy starting from the source
		// and return the first element that is instance of the container class.
		for (EObject element = source; element != null && container == null; element = element.eContainer())
		{
			if (element instanceof StoryPattern)
			{
				container = (StoryPattern) element;
			}
		}
		if (container == null)
		{
			return Collections.emptyList();
		}
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		for (Iterator<?> links = container.getStoryPatternLinks().iterator(); links.hasNext();)
		{
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof MapEntryLink)
			{
				continue;
			}
			MapEntryLink link = (MapEntryLink) linkObject;
			if (MapEntryLinkEditPart.VISUAL_ID != MlsdmVisualIDRegistry.getLinkWithClassVisualID(link))
			{
				continue;
			}
			AbstractStoryPatternObject dst = link.getTarget();
			AbstractStoryPatternObject src = link.getSource();
			if (src != source)
			{
				continue;
			}
			result.add(new MlsdmLinkDescriptor(src, dst, link, MlsdmElementTypes.MapEntryLink_4006, MapEntryLinkEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection<MlsdmLinkDescriptor> getOutgoingFeatureModelFacetLinks_MapEntryLink_ValueTarget_4007(MapEntryLink source)
	{
		LinkedList<MlsdmLinkDescriptor> result = new LinkedList<MlsdmLinkDescriptor>();
		AbstractStoryPatternObject destination = source.getValueTarget();
		if (destination == null)
		{
			return result;
		}
		result.add(new MlsdmLinkDescriptor(source, destination, MlsdmElementTypes.MapEntryLinkValueTarget_4007,
				MapEntryLinkValueTargetEditPart.VISUAL_ID));
		return result;
	}

	/**
	 * @generated
	 */
	public static final DiagramUpdater	TYPED_INSTANCE	= new DiagramUpdater()
														{
															/**
															 * @generated
															 */
															@Override
															public List<MlsdmNodeDescriptor> getSemanticChildren(View view)
															{
																return MlsdmDiagramUpdater.getSemanticChildren(view);
															}

															/**
															 * @generated
															 */
															@Override
															public List<MlsdmLinkDescriptor> getContainedLinks(View view)
															{
																return MlsdmDiagramUpdater.getContainedLinks(view);
															}

															/**
															 * @generated
															 */
															@Override
															public List<MlsdmLinkDescriptor> getIncomingLinks(View view)
															{
																return MlsdmDiagramUpdater.getIncomingLinks(view);
															}

															/**
															 * @generated
															 */
															@Override
															public List<MlsdmLinkDescriptor> getOutgoingLinks(View view)
															{
																return MlsdmDiagramUpdater.getOutgoingLinks(view);
															}
														};

}
