/**
 */
package de.mdelab.mlsdm.impl;

import java.lang.reflect.InvocationTargetException;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.EnumerationLiteralId;
import org.eclipse.ocl.pivot.ids.IdResolver;
import org.eclipse.ocl.pivot.ids.TypeId;
import org.eclipse.ocl.pivot.library.collection.CollectionIsEmptyOperation;
import org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation;
import org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation;
import org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation;
import org.eclipse.ocl.pivot.messages.PivotMessages;
import org.eclipse.ocl.pivot.utilities.ClassUtil;
import org.eclipse.ocl.pivot.utilities.PivotUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.IntegerValue;
import org.eclipse.ocl.pivot.values.InvalidValueException;
import org.eclipse.ocl.pivot.values.OrderedSetValue;
import org.eclipse.ocl.pivot.values.SetValue;
import org.eclipse.ocl.pivot.values.SetValue.Accumulator;
import org.eclipse.ocl.pivot.values.TupleValue;

import de.mdelab.mlcallactions.impl.ParameterizedCallActionImpl;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityCallAction;
import de.mdelab.mlsdm.ActivityParameter;
import de.mdelab.mlsdm.ActivityParameterDirectionEnum;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.MlsdmTables;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Activity Call Action</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityCallActionImpl#getActivity <em>Activity</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityCallActionImpl#getReturnValueParameter <em>Return Value Parameter</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.ActivityCallActionImpl#isImportOutputParameters <em>Import Output Parameters</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ActivityCallActionImpl extends ParameterizedCallActionImpl
		implements ActivityCallAction {
	/**
	 * The cached value of the '{@link #getActivity() <em>Activity</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getActivity()
	 * @generated
	 * @ordered
	 */
	protected Activity activity;

	/**
	 * The cached value of the '{@link #getReturnValueParameter() <em>Return Value Parameter</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getReturnValueParameter()
	 * @generated
	 * @ordered
	 */
	protected ActivityParameter returnValueParameter;

	/**
	 * The default value of the '{@link #isImportOutputParameters() <em>Import Output Parameters</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isImportOutputParameters()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IMPORT_OUTPUT_PARAMETERS_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isImportOutputParameters() <em>Import Output Parameters</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isImportOutputParameters()
	 * @generated
	 * @ordered
	 */
	protected boolean importOutputParameters = IMPORT_OUTPUT_PARAMETERS_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ActivityCallActionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlsdmPackage.Literals.ACTIVITY_CALL_ACTION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Activity getActivity() {
		if (activity != null && activity.eIsProxy()) {
			InternalEObject oldActivity = (InternalEObject) activity;
			activity = (Activity) eResolveProxy(oldActivity);
			if (activity != oldActivity) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE,
							MlsdmPackage.ACTIVITY_CALL_ACTION__ACTIVITY, oldActivity, activity));
			}
		}
		return activity;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Activity basicGetActivity() {
		return activity;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setActivity(Activity newActivity) {
		Activity oldActivity = activity;
		activity = newActivity;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MlsdmPackage.ACTIVITY_CALL_ACTION__ACTIVITY,
					oldActivity, activity));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ActivityParameter getReturnValueParameter() {
		if (returnValueParameter != null && returnValueParameter.eIsProxy()) {
			InternalEObject oldReturnValueParameter = (InternalEObject) returnValueParameter;
			returnValueParameter = (ActivityParameter) eResolveProxy(oldReturnValueParameter);
			if (returnValueParameter != oldReturnValueParameter) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE,
							MlsdmPackage.ACTIVITY_CALL_ACTION__RETURN_VALUE_PARAMETER, oldReturnValueParameter,
							returnValueParameter));
			}
		}
		return returnValueParameter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ActivityParameter basicGetReturnValueParameter() {
		return returnValueParameter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setReturnValueParameter(ActivityParameter newReturnValueParameter) {
		ActivityParameter oldReturnValueParameter = returnValueParameter;
		returnValueParameter = newReturnValueParameter;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlsdmPackage.ACTIVITY_CALL_ACTION__RETURN_VALUE_PARAMETER, oldReturnValueParameter,
					returnValueParameter));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isImportOutputParameters() {
		return importOutputParameters;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setImportOutputParameters(boolean newImportOutputParameters) {
		boolean oldImportOutputParameters = importOutputParameters;
		importOutputParameters = newImportOutputParameters;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlsdmPackage.ACTIVITY_CALL_ACTION__IMPORT_OUTPUT_PARAMETERS, oldImportOutputParameters,
					importOutputParameters));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean CallActionTypeNullWhenNoReturnParameter(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		final String constraintName = "ActivityCallAction::CallActionTypeNullWhenNoReturnParameter";
		try {
			/**
			 *
			 * inv CallActionTypeNullWhenNoReturnParameter:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if self.returnValueParameter = null
			 *           then self.type = null
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'The type of this activity call action must be null because no returnValueParameter is selected.', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
					MlsdmPackage.Literals.ACTIVITY_CALL_ACTION___CALL_ACTION_TYPE_NULL_WHEN_NO_RETURN_PARAMETER__DIAGNOSTICCHAIN_MAP);
			final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ boolean symbol_2;
			if (le) {
				symbol_2 = true;
			} else {
				final /*@NonInvalid*/ ActivityParameter returnValueParameter = this.getReturnValueParameter();
				final /*@NonInvalid*/ boolean eq = returnValueParameter == null;
				/*@NonInvalid*/ Boolean status;
				if (eq) {
					final /*@NonInvalid*/ EClassifier type = this.getType();
					final /*@NonInvalid*/ boolean eq_0 = type == null;
					status = eq_0;
				} else {
					status = null;
				}
				final /*@NonInvalid*/ boolean eq_1 = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq_1) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlsdmTables.TUPLid_,
							MlsdmTables.STR_The_32_type_32_of_32_this_32_activity_32_call_32_action_32_must_32_be_32_null_32_because_32_no_32_re,
							status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, severity_0, symbol_1, MlsdmTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean ParametersMatchActivity(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "ActivityCallAction::ParametersMatchActivity";
		try {
			/**
			 *
			 * inv ParametersMatchActivity:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if self.activity <> null
			 *           then
			 *             self.activity.parameters->select(par | par.direction <> ActivityParameterDirectionEnum::OUT)
			 *             ->forAll(par |
			 *               self.parameters->exists(par2 | par2.name = par.name and par2.type = par.type)) and
			 *             self.parameters->forAll(par |
			 *               self.activity.parameters->any(par2 | par2.name = par.name).direction <> ActivityParameterDirectionEnum::OUT)
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'The provided parameters do not match the activity\'s signature.', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
			final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
					MlsdmPackage.Literals.ACTIVITY_CALL_ACTION___PARAMETERS_MATCH_ACTIVITY__DIAGNOSTICCHAIN_MAP);
			final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ boolean symbol_2;
			if (le) {
				symbol_2 = true;
			} else {
				/*@Caught*/ Object CAUGHT_symbol_1;
				try {
					/*@Caught*/ Object CAUGHT_forAll;
					try {
						final /*@NonInvalid*/ Activity activity = this.getActivity();
						final /*@NonInvalid*/ List<ActivityParameter> parameters = activity.getParameters();
						final /*@NonInvalid*/ SetValue BOXED_parameters = idResolver
								.createSetOfAll(MlsdmTables.SET_CLSSid_ActivityParameter, parameters);
						/*@Thrown*/ Accumulator accumulator = ValueUtil
								.createSetAccumulatorValue(MlsdmTables.SET_CLSSid_ActivityParameter);
						Iterator<Object> ITERATOR_par = BOXED_parameters.iterator();
						/*@NonInvalid*/ SetValue select;
						while (true) {
							if (!ITERATOR_par.hasNext()) {
								select = accumulator;
								break;
							}
							/*@NonInvalid*/ ActivityParameter par = (ActivityParameter) ITERATOR_par.next();
							/**
							 * par.direction <> ActivityParameterDirectionEnum::OUT
							 */
							final /*@NonInvalid*/ ActivityParameterDirectionEnum direction = par.getDirection();
							final /*@NonInvalid*/ EnumerationLiteralId BOXED_direction = MlsdmTables.ENUMid_ActivityParameterDirectionEnum
									.getEnumerationLiteralId(ClassUtil.nonNullState(direction.getName()));
							final /*@NonInvalid*/ boolean ne = BOXED_direction != MlsdmTables.ELITid_OUT;
							//
							if (ne) {
								accumulator.add(par);
							}
						}
						/*@Thrown*/ Object accumulator_0 = ValueUtil.TRUE_VALUE;
						Iterator<Object> ITERATOR_par_0 = select.iterator();
						/*@Thrown*/ Boolean forAll;
						while (true) {
							if (!ITERATOR_par_0.hasNext()) {
								if (accumulator_0 == null) {
									forAll = null;
								} else if (accumulator_0 == ValueUtil.TRUE_VALUE) {
									forAll = ValueUtil.TRUE_VALUE;
								} else {
									throw (InvalidValueException) accumulator_0;
								}
								break;
							}
							/*@NonInvalid*/ ActivityParameter par_0 = (ActivityParameter) ITERATOR_par_0.next();
							/**
							 *
							 * self.parameters->exists(par2 | par2.name = par.name and par2.type = par.type)
							 */
							/*@Caught*/ Object CAUGHT_exists;
							try {
								final /*@NonInvalid*/ List<de.mdelab.mlcallactions.CallActionParameter> parameters_0 = this
										.getParameters();
								final /*@NonInvalid*/ OrderedSetValue BOXED_parameters_0 = idResolver
										.createOrderedSetOfAll(MlsdmTables.ORD_CLSSid_CallActionParameter,
												parameters_0);
								/*@Thrown*/ Object accumulator_1 = ValueUtil.FALSE_VALUE;
								Iterator<Object> ITERATOR_par2 = BOXED_parameters_0.iterator();
								/*@Thrown*/ Boolean exists;
								while (true) {
									if (!ITERATOR_par2.hasNext()) {
										if (accumulator_1 == null) {
											exists = null;
										} else if (accumulator_1 == ValueUtil.FALSE_VALUE) {
											exists = ValueUtil.FALSE_VALUE;
										} else {
											throw (InvalidValueException) accumulator_1;
										}
										break;
									}
									/*@NonInvalid*/ de.mdelab.mlcallactions.CallActionParameter par2 = (de.mdelab.mlcallactions.CallActionParameter) ITERATOR_par2
											.next();
									/**
									 * par2.name = par.name and par2.type = par.type
									 */
									final /*@NonInvalid*/ String name = par2.getName();
									final /*@NonInvalid*/ String name_0 = par_0.getName();
									final /*@NonInvalid*/ boolean eq = (name != null) ? name.equals(name_0)
											: (name_0 == null);
									final /*@NonInvalid*/ Boolean and;
									if (!eq) {
										and = ValueUtil.FALSE_VALUE;
									} else {
										final /*@NonInvalid*/ EClassifier type = par2.getType();
										final /*@NonInvalid*/ EClassifier type_0 = par_0.getType();
										final /*@NonInvalid*/ boolean eq_0 = (type != null) ? type.equals(type_0)
												: (type_0 == null);
										if (!eq_0) {
											and = ValueUtil.FALSE_VALUE;
										} else {
											and = ValueUtil.TRUE_VALUE;
										}
									}
									//
									if (and == ValueUtil.TRUE_VALUE) { // Normal successful body evaluation result
										exists = ValueUtil.TRUE_VALUE;
										break; // Stop immediately
									} else if (and == ValueUtil.FALSE_VALUE) { // Normal unsuccessful body evaluation result
										; // Carry on
									} else if (and == null) { // Abnormal null body evaluation result
										if (accumulator_1 == ValueUtil.FALSE_VALUE) {
											accumulator_1 = null; // Cache a null failure
										}
									} else { // Impossible badly typed result
										accumulator_1 = new InvalidValueException(PivotMessages.NonBooleanBody,
												"exists");
									}
								}
								CAUGHT_exists = exists;
							} catch (Exception e) {
								CAUGHT_exists = ValueUtil.createInvalidValue(e);
							}
							//
							if (CAUGHT_exists == ValueUtil.FALSE_VALUE) { // Normal unsuccessful body evaluation result
								forAll = ValueUtil.FALSE_VALUE;
								break; // Stop immediately
							} else if (CAUGHT_exists == ValueUtil.TRUE_VALUE) { // Normal successful body evaluation result
								; // Carry on
							} else if (CAUGHT_exists == null) { // Abnormal null body evaluation result
								if (accumulator_0 == ValueUtil.TRUE_VALUE) {
									accumulator_0 = null; // Cache a null failure
								}
							} else if (CAUGHT_exists instanceof InvalidValueException) { // Abnormal exception evaluation result
								accumulator_0 = CAUGHT_exists; // Cache an exception failure
							} else { // Impossible badly typed result
								accumulator_0 = new InvalidValueException(PivotMessages.NonBooleanBody, "forAll");
							}
						}
						CAUGHT_forAll = forAll;
					} catch (Exception e) {
						CAUGHT_forAll = ValueUtil.createInvalidValue(e);
					}
					final /*@Thrown*/ Boolean and_0;
					if (CAUGHT_forAll == ValueUtil.FALSE_VALUE) {
						and_0 = ValueUtil.FALSE_VALUE;
					} else {
						/*@Caught*/ Object CAUGHT_forAll_0;
						try {
							final /*@NonInvalid*/ List<de.mdelab.mlcallactions.CallActionParameter> parameters_1 = this
									.getParameters();
							final /*@NonInvalid*/ OrderedSetValue BOXED_parameters_1 = idResolver
									.createOrderedSetOfAll(MlsdmTables.ORD_CLSSid_CallActionParameter, parameters_1);
							/*@Thrown*/ Object accumulator_2 = ValueUtil.TRUE_VALUE;
							Iterator<Object> ITERATOR_par_1 = BOXED_parameters_1.iterator();
							/*@Thrown*/ Boolean forAll_0;
							while (true) {
								if (!ITERATOR_par_1.hasNext()) {
									if (accumulator_2 == ValueUtil.TRUE_VALUE) {
										forAll_0 = ValueUtil.TRUE_VALUE;
									} else {
										throw (InvalidValueException) accumulator_2;
									}
									break;
								}
								/*@NonInvalid*/ de.mdelab.mlcallactions.CallActionParameter par_1 = (de.mdelab.mlcallactions.CallActionParameter) ITERATOR_par_1
										.next();
								/**
								 * self.activity.parameters->any(par2 | par2.name = par.name).direction <> ActivityParameterDirectionEnum::OUT
								 */
								/*@Caught*/ Object CAUGHT_ne_0;
								try {
									final /*@NonInvalid*/ Activity activity_0 = this.getActivity();
									final /*@NonInvalid*/ List<ActivityParameter> parameters_2 = activity_0
											.getParameters();
									final /*@NonInvalid*/ SetValue BOXED_parameters_2 = idResolver
											.createSetOfAll(MlsdmTables.SET_CLSSid_ActivityParameter, parameters_2);
									Iterator<Object> ITERATOR_par2_0 = BOXED_parameters_2.iterator();
									/*@Thrown*/ ActivityParameter any;
									while (true) {
										if (!ITERATOR_par2_0.hasNext()) {
											throw new InvalidValueException("Nothing to return for ''any''");
										}
										/*@NonInvalid*/ ActivityParameter par2_0 = (ActivityParameter) ITERATOR_par2_0
												.next();
										/**
										 * par2.name = par.name
										 */
										final /*@NonInvalid*/ String name_1 = par2_0.getName();
										final /*@NonInvalid*/ String name_2 = par_1.getName();
										final /*@NonInvalid*/ boolean eq_1 = (name_1 != null) ? name_1.equals(name_2)
												: (name_2 == null);
										//
										if (eq_1) { // Carry on till something found
											any = par2_0;
											break;
										}
									}
									final /*@Thrown*/ ActivityParameterDirectionEnum direction_0 = any.getDirection();
									final /*@Thrown*/ EnumerationLiteralId BOXED_direction_0 = MlsdmTables.ENUMid_ActivityParameterDirectionEnum
											.getEnumerationLiteralId(ClassUtil.nonNullState(direction_0.getName()));
									final /*@Thrown*/ boolean ne_0 = BOXED_direction_0 != MlsdmTables.ELITid_OUT;
									CAUGHT_ne_0 = ne_0;
								} catch (Exception e) {
									CAUGHT_ne_0 = ValueUtil.createInvalidValue(e);
								}
								//
								if (CAUGHT_ne_0 == ValueUtil.FALSE_VALUE) { // Normal unsuccessful body evaluation result
									forAll_0 = ValueUtil.FALSE_VALUE;
									break; // Stop immediately
								} else if (CAUGHT_ne_0 == ValueUtil.TRUE_VALUE) { // Normal successful body evaluation result
									; // Carry on
								} else if (CAUGHT_ne_0 instanceof InvalidValueException) { // Abnormal exception evaluation result
									accumulator_2 = CAUGHT_ne_0; // Cache an exception failure
								} else { // Impossible badly typed result
									accumulator_2 = new InvalidValueException(PivotMessages.NonBooleanBody, "forAll");
								}
							}
							CAUGHT_forAll_0 = forAll_0;
						} catch (Exception e) {
							CAUGHT_forAll_0 = ValueUtil.createInvalidValue(e);
						}
						if (CAUGHT_forAll_0 == ValueUtil.FALSE_VALUE) {
							and_0 = ValueUtil.FALSE_VALUE;
						} else {
							if (CAUGHT_forAll instanceof InvalidValueException) {
								throw (InvalidValueException) CAUGHT_forAll;
							}
							if (CAUGHT_forAll_0 instanceof InvalidValueException) {
								throw (InvalidValueException) CAUGHT_forAll_0;
							}
							if ((CAUGHT_forAll == null) || (CAUGHT_forAll_0 == null)) {
								and_0 = null;
							} else {
								and_0 = ValueUtil.TRUE_VALUE;
							}
						}
					}
					final /*@Thrown*/ boolean eq_2 = and_0 == Boolean.TRUE;
					/*@Thrown*/ Object symbol_1;
					if (eq_2) {
						symbol_1 = ValueUtil.TRUE_VALUE;
					} else {
						final /*@Thrown*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlsdmTables.TUPLid_,
								MlsdmTables.STR_The_32_provided_32_parameters_32_do_32_not_32_match_32_the_32_activity_39_s_32_signature,
								and_0);
						symbol_1 = symbol_0;
					}
					CAUGHT_symbol_1 = symbol_1;
				} catch (Exception e) {
					CAUGHT_symbol_1 = ValueUtil.createInvalidValue(e);
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, severity_0, CAUGHT_symbol_1, MlsdmTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean ReturnValueParameterExists(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "ActivityCallAction::ReturnValueParameterExists";
		try {
			/**
			 *
			 * inv ReturnValueParameterExists:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if self.activity <> null and
			 *             not self.activity.parameters->select(par |
			 *               (par.direction = ActivityParameterDirectionEnum::IN
			 *               ))
			 *             ->isEmpty()
			 *           then self.returnValueParameter <> null
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'A returnValueParameter must be selected.', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
			final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
					MlsdmPackage.Literals.ACTIVITY_CALL_ACTION___RETURN_VALUE_PARAMETER_EXISTS__DIAGNOSTICCHAIN_MAP);
			final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ boolean symbol_2;
			if (le) {
				symbol_2 = true;
			} else {
				final /*@Thrown*/ Boolean and;
				final /*@NonInvalid*/ Activity activity = this.getActivity();
				final /*@NonInvalid*/ List<ActivityParameter> parameters = activity.getParameters();
				final /*@NonInvalid*/ SetValue BOXED_parameters = idResolver
						.createSetOfAll(MlsdmTables.SET_CLSSid_ActivityParameter, parameters);
				/*@Thrown*/ Accumulator accumulator = ValueUtil
						.createSetAccumulatorValue(MlsdmTables.SET_CLSSid_ActivityParameter);
				Iterator<Object> ITERATOR_par = BOXED_parameters.iterator();
				/*@NonInvalid*/ SetValue select;
				while (true) {
					if (!ITERATOR_par.hasNext()) {
						select = accumulator;
						break;
					}
					/*@NonInvalid*/ ActivityParameter par = (ActivityParameter) ITERATOR_par.next();
					/**
					 * par.direction = ActivityParameterDirectionEnum::IN
					 */
					final /*@NonInvalid*/ ActivityParameterDirectionEnum direction = par.getDirection();
					final /*@NonInvalid*/ EnumerationLiteralId BOXED_direction = MlsdmTables.ENUMid_ActivityParameterDirectionEnum
							.getEnumerationLiteralId(ClassUtil.nonNullState(direction.getName()));
					final /*@NonInvalid*/ boolean eq = BOXED_direction == MlsdmTables.ELITid_IN;
					//
					if (eq) {
						accumulator.add(par);
					}
				}
				final /*@NonInvalid*/ boolean isEmpty = CollectionIsEmptyOperation.INSTANCE.evaluate(select)
						.booleanValue();
				final /*@NonInvalid*/ Boolean not;
				if (!isEmpty) {
					not = ValueUtil.TRUE_VALUE;
				} else {
					if (isEmpty) {
						not = ValueUtil.FALSE_VALUE;
					} else {
						not = null;
					}
				}
				and = (Boolean) not;
				if (and == null) {
					throw new InvalidValueException("Null if condition");
				}
				/*@NonInvalid*/ Boolean status;
				if (and) {
					final /*@NonInvalid*/ ActivityParameter returnValueParameter = this.getReturnValueParameter();
					final /*@NonInvalid*/ boolean ne = returnValueParameter != null;
					status = ne;
				} else {
					status = null;
				}
				final /*@NonInvalid*/ boolean eq_0 = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq_0) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlsdmTables.TUPLid_,
							MlsdmTables.STR_A_32_returnValueParameter_32_must_32_be_32_selected, status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, severity_0, symbol_1, MlsdmTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean CallActionTypeEqualsReturnParameterType(final DiagnosticChain diagnostics,
			final Map<Object, Object> context) {
		final String constraintName = "ActivityCallAction::CallActionTypeEqualsReturnParameterType";
		try {
			/**
			 *
			 * inv CallActionTypeEqualsReturnParameterType:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if self.returnValueParameter <> null
			 *           then self.type = self.returnValueParameter
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'The type of this activity call action must be equal to the type of the selected returnValueParameter.', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
					MlsdmPackage.Literals.ACTIVITY_CALL_ACTION___CALL_ACTION_TYPE_EQUALS_RETURN_PARAMETER_TYPE__DIAGNOSTICCHAIN_MAP);
			final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ boolean symbol_2;
			if (le) {
				symbol_2 = true;
			} else {
				final /*@NonInvalid*/ ActivityParameter returnValueParameter_0 = this.getReturnValueParameter();
				final /*@NonInvalid*/ boolean ne = returnValueParameter_0 != null;
				/*@NonInvalid*/ Boolean status;
				if (ne) {
					final /*@NonInvalid*/ EClassifier type = this.getType();
					final /*@NonInvalid*/ boolean eq = (type != null) ? type.equals(returnValueParameter_0)
							: (returnValueParameter_0 == null);
					status = eq;
				} else {
					status = null;
				}
				final /*@NonInvalid*/ boolean eq_0 = status == Boolean.TRUE;
				/*@NonInvalid*/ Object symbol_1;
				if (eq_0) {
					symbol_1 = ValueUtil.TRUE_VALUE;
				} else {
					final /*@NonInvalid*/ TupleValue symbol_0 = ValueUtil.createTupleOfEach(MlsdmTables.TUPLid_,
							MlsdmTables.STR_The_32_type_32_of_32_this_32_activity_32_call_32_action_32_must_32_be_32_equal_32_to_32_the_32_type_32,
							status);
					symbol_1 = symbol_0;
				}
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, severity_0, symbol_1, MlsdmTables.INT_0)
						.booleanValue();
				symbol_2 = logDiagnostic;
			}
			return symbol_2;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case MlsdmPackage.ACTIVITY_CALL_ACTION__ACTIVITY:
			if (resolve)
				return getActivity();
			return basicGetActivity();
		case MlsdmPackage.ACTIVITY_CALL_ACTION__RETURN_VALUE_PARAMETER:
			if (resolve)
				return getReturnValueParameter();
			return basicGetReturnValueParameter();
		case MlsdmPackage.ACTIVITY_CALL_ACTION__IMPORT_OUTPUT_PARAMETERS:
			return isImportOutputParameters();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case MlsdmPackage.ACTIVITY_CALL_ACTION__ACTIVITY:
			setActivity((Activity) newValue);
			return;
		case MlsdmPackage.ACTIVITY_CALL_ACTION__RETURN_VALUE_PARAMETER:
			setReturnValueParameter((ActivityParameter) newValue);
			return;
		case MlsdmPackage.ACTIVITY_CALL_ACTION__IMPORT_OUTPUT_PARAMETERS:
			setImportOutputParameters((Boolean) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case MlsdmPackage.ACTIVITY_CALL_ACTION__ACTIVITY:
			setActivity((Activity) null);
			return;
		case MlsdmPackage.ACTIVITY_CALL_ACTION__RETURN_VALUE_PARAMETER:
			setReturnValueParameter((ActivityParameter) null);
			return;
		case MlsdmPackage.ACTIVITY_CALL_ACTION__IMPORT_OUTPUT_PARAMETERS:
			setImportOutputParameters(IMPORT_OUTPUT_PARAMETERS_EDEFAULT);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case MlsdmPackage.ACTIVITY_CALL_ACTION__ACTIVITY:
			return activity != null;
		case MlsdmPackage.ACTIVITY_CALL_ACTION__RETURN_VALUE_PARAMETER:
			return returnValueParameter != null;
		case MlsdmPackage.ACTIVITY_CALL_ACTION__IMPORT_OUTPUT_PARAMETERS:
			return importOutputParameters != IMPORT_OUTPUT_PARAMETERS_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments) throws InvocationTargetException {
		switch (operationID) {
		case MlsdmPackage.ACTIVITY_CALL_ACTION___CALL_ACTION_TYPE_NULL_WHEN_NO_RETURN_PARAMETER__DIAGNOSTICCHAIN_MAP:
			return CallActionTypeNullWhenNoReturnParameter((DiagnosticChain) arguments.get(0),
					(Map<Object, Object>) arguments.get(1));
		case MlsdmPackage.ACTIVITY_CALL_ACTION___PARAMETERS_MATCH_ACTIVITY__DIAGNOSTICCHAIN_MAP:
			return ParametersMatchActivity((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		case MlsdmPackage.ACTIVITY_CALL_ACTION___RETURN_VALUE_PARAMETER_EXISTS__DIAGNOSTICCHAIN_MAP:
			return ReturnValueParameterExists((DiagnosticChain) arguments.get(0),
					(Map<Object, Object>) arguments.get(1));
		case MlsdmPackage.ACTIVITY_CALL_ACTION___CALL_ACTION_TYPE_EQUALS_RETURN_PARAMETER_TYPE__DIAGNOSTICCHAIN_MAP:
			return CallActionTypeEqualsReturnParameterType((DiagnosticChain) arguments.get(0),
					(Map<Object, Object>) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (importOutputParameters: ");
		result.append(importOutputParameters);
		result.append(')');
		return result.toString();
	}

} //ActivityCallActionImpl
