/**
 */
package de.mdelab.mlsdm.impl;

import java.lang.reflect.InvocationTargetException;
import java.util.Collection;
import java.util.Map;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.TypeId;
import org.eclipse.ocl.pivot.library.oclany.OclComparableLessThanEqualOperation;
import org.eclipse.ocl.pivot.library.string.CGStringGetSeverityOperation;
import org.eclipse.ocl.pivot.library.string.CGStringLogDiagnosticOperation;
import org.eclipse.ocl.pivot.utilities.PivotUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.IntegerValue;

import de.mdelab.mlannotations.MLAnnotation;
import de.mdelab.mlannotations.MlannotationsPackage;
import de.mdelab.mlcore.MLAnnotatedElement;
import de.mdelab.mlcore.MlcorePackage;
import de.mdelab.mlcore.impl.MLElementWithUUIDImpl;
import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlsdm.ActivityFinalNode;
import de.mdelab.mlsdm.ActivityParameter;
import de.mdelab.mlsdm.MlsdmPackage;
import de.mdelab.mlsdm.MlsdmTables;
import de.mdelab.mlsdm.OutputParameterValue;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Output Parameter Value</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.mdelab.mlsdm.impl.OutputParameterValueImpl#getAnnotations <em>Annotations</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.OutputParameterValueImpl#getParameter <em>Parameter</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.OutputParameterValueImpl#getExpression <em>Expression</em>}</li>
 *   <li>{@link de.mdelab.mlsdm.impl.OutputParameterValueImpl#getActivityFinalNode <em>Activity Final Node</em>}</li>
 * </ul>
 *
 * @generated
 */
public class OutputParameterValueImpl extends MLElementWithUUIDImpl implements OutputParameterValue {
	/**
	 * The cached value of the '{@link #getAnnotations() <em>Annotations</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getAnnotations()
	 * @generated
	 * @ordered
	 */
	protected EList<MLAnnotation> annotations;

	/**
	 * The cached value of the '{@link #getParameter() <em>Parameter</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getParameter()
	 * @generated
	 * @ordered
	 */
	protected ActivityParameter parameter;

	/**
	 * The cached value of the '{@link #getExpression() <em>Expression</em>}' containment reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getExpression()
	 * @generated
	 * @ordered
	 */
	protected MLExpression expression;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected OutputParameterValueImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return MlsdmPackage.Literals.OUTPUT_PARAMETER_VALUE;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<MLAnnotation> getAnnotations() {
		if (annotations == null) {
			annotations = new EObjectContainmentWithInverseEList<MLAnnotation>(MLAnnotation.class, this,
					MlsdmPackage.OUTPUT_PARAMETER_VALUE__ANNOTATIONS, MlannotationsPackage.ML_ANNOTATION__ELEMENT);
		}
		return annotations;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ActivityParameter getParameter() {
		return parameter;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setParameter(ActivityParameter newParameter) {
		ActivityParameter oldParameter = parameter;
		parameter = newParameter;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MlsdmPackage.OUTPUT_PARAMETER_VALUE__PARAMETER,
					oldParameter, parameter));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public MLExpression getExpression() {
		return expression;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetExpression(MLExpression newExpression, NotificationChain msgs) {
		MLExpression oldExpression = expression;
		expression = newExpression;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
					MlsdmPackage.OUTPUT_PARAMETER_VALUE__EXPRESSION, oldExpression, newExpression);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setExpression(MLExpression newExpression) {
		if (newExpression != expression) {
			NotificationChain msgs = null;
			if (expression != null)
				msgs = ((InternalEObject) expression).eInverseRemove(this,
						EOPPOSITE_FEATURE_BASE - MlsdmPackage.OUTPUT_PARAMETER_VALUE__EXPRESSION, null, msgs);
			if (newExpression != null)
				msgs = ((InternalEObject) newExpression).eInverseAdd(this,
						EOPPOSITE_FEATURE_BASE - MlsdmPackage.OUTPUT_PARAMETER_VALUE__EXPRESSION, null, msgs);
			msgs = basicSetExpression(newExpression, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, MlsdmPackage.OUTPUT_PARAMETER_VALUE__EXPRESSION,
					newExpression, newExpression));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ActivityFinalNode getActivityFinalNode() {
		if (eContainerFeatureID() != MlsdmPackage.OUTPUT_PARAMETER_VALUE__ACTIVITY_FINAL_NODE)
			return null;
		return (ActivityFinalNode) eInternalContainer();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetActivityFinalNode(ActivityFinalNode newActivityFinalNode, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject) newActivityFinalNode,
				MlsdmPackage.OUTPUT_PARAMETER_VALUE__ACTIVITY_FINAL_NODE, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setActivityFinalNode(ActivityFinalNode newActivityFinalNode) {
		if (newActivityFinalNode != eInternalContainer()
				|| (eContainerFeatureID() != MlsdmPackage.OUTPUT_PARAMETER_VALUE__ACTIVITY_FINAL_NODE
						&& newActivityFinalNode != null)) {
			if (EcoreUtil.isAncestor(this, newActivityFinalNode))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newActivityFinalNode != null)
				msgs = ((InternalEObject) newActivityFinalNode).eInverseAdd(this,
						MlsdmPackage.ACTIVITY_FINAL_NODE__OUTPUT_PARAMETER_VALUES, ActivityFinalNode.class, msgs);
			msgs = basicSetActivityFinalNode(newActivityFinalNode, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					MlsdmPackage.OUTPUT_PARAMETER_VALUE__ACTIVITY_FINAL_NODE, newActivityFinalNode,
					newActivityFinalNode));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean ExpressionSpecfied(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "OutputParameterValue::ExpressionSpecfied";
		try {
			/**
			 *
			 * inv ExpressionSpecfied:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if self.expression <> null
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'Expression of output parameter value assignment ' +
			 *               self.toString() + ' must be specified.', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
					MlsdmPackage.Literals.OUTPUT_PARAMETER_VALUE___EXPRESSION_SPECFIED__DIAGNOSTICCHAIN_MAP);
			final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ boolean symbol_0;
			if (le) {
				symbol_0 = true;
			} else {
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, severity_0, ValueUtil.TRUE_VALUE, MlsdmTables.INT_0)
						.booleanValue();
				symbol_0 = logDiagnostic;
			}
			return symbol_0;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean ParameterSpecfied(final DiagnosticChain diagnostics, final Map<Object, Object> context) {
		final String constraintName = "OutputParameterValue::ParameterSpecfied";
		try {
			/**
			 *
			 * inv ParameterSpecfied:
			 *   let severity : Integer[1] = constraintName.getSeverity()
			 *   in
			 *     if severity <= 0
			 *     then true
			 *     else
			 *       let
			 *         result : OclAny[1] = let
			 *           status : Boolean[?] = if self.parameter <> null
			 *           then true
			 *           else null
			 *           endif
			 *         in
			 *           if status = true
			 *           then true
			 *           else
			 *             Tuple{message = 'Parameter of output parameter value assignment ' +
			 *               self.toString() + ' must be specified.', status = status
			 *             }
			 *           endif
			 *       in
			 *         constraintName.logDiagnostic(self, null, diagnostics, context, null, severity, result, 0)
			 *     endif
			 */
			final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this, context);
			final /*@NonInvalid*/ IntegerValue severity_0 = CGStringGetSeverityOperation.INSTANCE.evaluate(executor,
					MlsdmPackage.Literals.OUTPUT_PARAMETER_VALUE___PARAMETER_SPECFIED__DIAGNOSTICCHAIN_MAP);
			final /*@NonInvalid*/ boolean le = OclComparableLessThanEqualOperation.INSTANCE
					.evaluate(executor, severity_0, MlsdmTables.INT_0).booleanValue();
			/*@NonInvalid*/ boolean symbol_0;
			if (le) {
				symbol_0 = true;
			} else {
				final /*@NonInvalid*/ boolean logDiagnostic = CGStringLogDiagnosticOperation.INSTANCE
						.evaluate(executor, TypeId.BOOLEAN, constraintName, this, (Object) null, diagnostics, context,
								(Object) null, severity_0, ValueUtil.TRUE_VALUE, MlsdmTables.INT_0)
						.booleanValue();
				symbol_0 = logDiagnostic;
			}
			return symbol_0;
		} catch (Throwable e) {
			return ValueUtil.validationFailedDiagnostic(constraintName, this, diagnostics, context, e);
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlsdmPackage.OUTPUT_PARAMETER_VALUE__ANNOTATIONS:
			return ((InternalEList<InternalEObject>) (InternalEList<?>) getAnnotations()).basicAdd(otherEnd, msgs);
		case MlsdmPackage.OUTPUT_PARAMETER_VALUE__ACTIVITY_FINAL_NODE:
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			return basicSetActivityFinalNode((ActivityFinalNode) otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
		case MlsdmPackage.OUTPUT_PARAMETER_VALUE__ANNOTATIONS:
			return ((InternalEList<?>) getAnnotations()).basicRemove(otherEnd, msgs);
		case MlsdmPackage.OUTPUT_PARAMETER_VALUE__EXPRESSION:
			return basicSetExpression(null, msgs);
		case MlsdmPackage.OUTPUT_PARAMETER_VALUE__ACTIVITY_FINAL_NODE:
			return basicSetActivityFinalNode(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
		case MlsdmPackage.OUTPUT_PARAMETER_VALUE__ACTIVITY_FINAL_NODE:
			return eInternalContainer().eInverseRemove(this, MlsdmPackage.ACTIVITY_FINAL_NODE__OUTPUT_PARAMETER_VALUES,
					ActivityFinalNode.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case MlsdmPackage.OUTPUT_PARAMETER_VALUE__ANNOTATIONS:
			return getAnnotations();
		case MlsdmPackage.OUTPUT_PARAMETER_VALUE__PARAMETER:
			return getParameter();
		case MlsdmPackage.OUTPUT_PARAMETER_VALUE__EXPRESSION:
			return getExpression();
		case MlsdmPackage.OUTPUT_PARAMETER_VALUE__ACTIVITY_FINAL_NODE:
			return getActivityFinalNode();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case MlsdmPackage.OUTPUT_PARAMETER_VALUE__ANNOTATIONS:
			getAnnotations().clear();
			getAnnotations().addAll((Collection<? extends MLAnnotation>) newValue);
			return;
		case MlsdmPackage.OUTPUT_PARAMETER_VALUE__PARAMETER:
			setParameter((ActivityParameter) newValue);
			return;
		case MlsdmPackage.OUTPUT_PARAMETER_VALUE__EXPRESSION:
			setExpression((MLExpression) newValue);
			return;
		case MlsdmPackage.OUTPUT_PARAMETER_VALUE__ACTIVITY_FINAL_NODE:
			setActivityFinalNode((ActivityFinalNode) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case MlsdmPackage.OUTPUT_PARAMETER_VALUE__ANNOTATIONS:
			getAnnotations().clear();
			return;
		case MlsdmPackage.OUTPUT_PARAMETER_VALUE__PARAMETER:
			setParameter((ActivityParameter) null);
			return;
		case MlsdmPackage.OUTPUT_PARAMETER_VALUE__EXPRESSION:
			setExpression((MLExpression) null);
			return;
		case MlsdmPackage.OUTPUT_PARAMETER_VALUE__ACTIVITY_FINAL_NODE:
			setActivityFinalNode((ActivityFinalNode) null);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case MlsdmPackage.OUTPUT_PARAMETER_VALUE__ANNOTATIONS:
			return annotations != null && !annotations.isEmpty();
		case MlsdmPackage.OUTPUT_PARAMETER_VALUE__PARAMETER:
			return parameter != null;
		case MlsdmPackage.OUTPUT_PARAMETER_VALUE__EXPRESSION:
			return expression != null;
		case MlsdmPackage.OUTPUT_PARAMETER_VALUE__ACTIVITY_FINAL_NODE:
			return getActivityFinalNode() != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == MLAnnotatedElement.class) {
			switch (derivedFeatureID) {
			case MlsdmPackage.OUTPUT_PARAMETER_VALUE__ANNOTATIONS:
				return MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS;
			default:
				return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == MLAnnotatedElement.class) {
			switch (baseFeatureID) {
			case MlcorePackage.ML_ANNOTATED_ELEMENT__ANNOTATIONS:
				return MlsdmPackage.OUTPUT_PARAMETER_VALUE__ANNOTATIONS;
			default:
				return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	@SuppressWarnings("unchecked")
	public Object eInvoke(int operationID, EList<?> arguments) throws InvocationTargetException {
		switch (operationID) {
		case MlsdmPackage.OUTPUT_PARAMETER_VALUE___EXPRESSION_SPECFIED__DIAGNOSTICCHAIN_MAP:
			return ExpressionSpecfied((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		case MlsdmPackage.OUTPUT_PARAMETER_VALUE___PARAMETER_SPECFIED__DIAGNOSTICCHAIN_MAP:
			return ParameterSpecfied((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

} // OutputParameterValueImpl
